/* DrawingService.c generated by valac 0.39.7, the Vala compiler
 * generated from DrawingService.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo.h>


#define PLANK_TYPE_DRAWING_SERVICE (plank_drawing_service_get_type ())
#define PLANK_DRAWING_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_DRAWING_SERVICE, PlankDrawingService))
#define PLANK_DRAWING_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_DRAWING_SERVICE, PlankDrawingServiceClass))
#define PLANK_IS_DRAWING_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_DRAWING_SERVICE))
#define PLANK_IS_DRAWING_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_DRAWING_SERVICE))
#define PLANK_DRAWING_SERVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_DRAWING_SERVICE, PlankDrawingServiceClass))

typedef struct _PlankDrawingService PlankDrawingService;
typedef struct _PlankDrawingServiceClass PlankDrawingServiceClass;
typedef struct _PlankDrawingServicePrivate PlankDrawingServicePrivate;
enum  {
	PLANK_DRAWING_SERVICE_0_PROPERTY,
	PLANK_DRAWING_SERVICE_NUM_PROPERTIES
};
static GParamSpec* plank_drawing_service_properties[PLANK_DRAWING_SERVICE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _gtk_icon_info_free0(var) ((var == NULL) ? NULL : (var = (gtk_icon_info_free (var), NULL)))

#define PLANK_TYPE_COLOR (plank_color_get_type ())
typedef GdkRGBA PlankColor;

struct _PlankDrawingService {
	GObject parent_instance;
	PlankDrawingServicePrivate * priv;
};

struct _PlankDrawingServiceClass {
	GObjectClass parent_class;
};


static gpointer plank_drawing_service_parent_class = NULL;
static GMutex plank_drawing_service_icon_theme_mutex;
static GMutex plank_drawing_service_icon_theme_mutex = {0};
static GtkIconTheme* plank_drawing_service_icon_theme;
static GtkIconTheme* plank_drawing_service_icon_theme = NULL;

GType plank_drawing_service_get_type (void) G_GNUC_CONST;
#define PLANK_DRAWING_SERVICE_DEFAULT_ICON "application-default-icon"
#define PLANK_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON "metadata::custom-icon"
#define PLANK_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON_NAME "metadata::custom-icon-name"
#define PLANK_DRAWING_SERVICE_SATURATION_WEIGHT 1.5
#define PLANK_DRAWING_SERVICE_WEIGHT_THRESHOLD 1.0
#define PLANK_DRAWING_SERVICE_ALPHA_THRESHOLD ((guint8) 24)
static PlankDrawingService* plank_drawing_service_new (void);
static PlankDrawingService* plank_drawing_service_construct (GType object_type);
GtkIconTheme* plank_drawing_service_get_icon_theme (void);
gchar* plank_drawing_service_get_icon_from_file (GFile* file);
gchar* plank_drawing_service_get_icon_from_gicon (GIcon* icon);
GdkPixbuf* plank_drawing_service_load_icon (const gchar* names,
                                            gint width,
                                            gint height);
static void _vala_array_add3 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
GFile* plank_drawing_service_try_get_icon_file (const gchar* name);
static GdkPixbuf* plank_drawing_service_load_pixbuf_from_file (GFile* file,
                                                        gint width,
                                                        gint height);
static GdkPixbuf* plank_drawing_service_load_pixbuf (const gchar* icon,
                                              gint size);
static GdkPixbuf* plank_drawing_service_load_pixbuf_from_resource (const gchar* resource,
                                                            gint width,
                                                            gint height);
#define PLANK_G_RESOURCE_PATH "/net/launchpad/plank"
GdkPixbuf* plank_drawing_service_ar_scale (GdkPixbuf* source,
                                           gint width,
                                           gint height);
static GdkPixbuf* plank_drawing_service_get_empty_pixbuf (gint width,
                                                   gint height);
cairo_surface_t* plank_drawing_service_load_icon_for_scale (const gchar* names,
                                                            gint width,
                                                            gint height,
                                                            gint scale);
static void _vala_array_add4 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static cairo_surface_t* plank_drawing_service_load_surface (const gchar* icon,
                                                     gint size,
                                                     gint scale);
static cairo_surface_t* plank_drawing_service_load_surface_from_resource_at_scale (const gchar* resource,
                                                                            gint width,
                                                                            gint height,
                                                                            gint scale);
GType plank_color_get_type (void) G_GNUC_CONST;
PlankColor* plank_color_dup (const PlankColor* self);
void plank_color_free (PlankColor* self);
void plank_drawing_service_average_color (GdkPixbuf* source,
                                          PlankColor* result);
static void plank_drawing_service_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static PlankDrawingService*
plank_drawing_service_construct (GType object_type)
{
	PlankDrawingService * self = NULL;
	self = (PlankDrawingService*) g_object_new (object_type, NULL);
	return self;
}


static PlankDrawingService*
plank_drawing_service_new (void)
{
	return plank_drawing_service_construct (PLANK_TYPE_DRAWING_SERVICE);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


GtkIconTheme*
plank_drawing_service_get_icon_theme (void)
{
	GtkIconTheme* result = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp4_;
	g_mutex_lock (&plank_drawing_service_icon_theme_mutex);
	_tmp0_ = plank_drawing_service_icon_theme;
	if (_tmp0_ == NULL) {
		GdkScreen* _tmp1_;
		GtkIconTheme* _tmp2_;
		GtkIconTheme* _tmp3_;
		_tmp1_ = gdk_screen_get_default ();
		_tmp2_ = gtk_icon_theme_get_for_screen (_tmp1_);
		_tmp3_ = _g_object_ref0 (_tmp2_);
		_g_object_unref0 (plank_drawing_service_icon_theme);
		plank_drawing_service_icon_theme = _tmp3_;
	}
	g_mutex_unlock (&plank_drawing_service_icon_theme_mutex);
	_tmp4_ = plank_drawing_service_icon_theme;
	result = _tmp4_;
	return result;
}


/**
 * Gets the icon name from a {@link GLib.File}.
 *
 * @param file the file to get the icon name for
 * @return the icon name for the file, or null if none exists
 */
gchar*
plank_drawing_service_get_icon_from_file (GFile* file)
{
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	{
		GFileInfo* info = NULL;
		GFileInfo* _tmp0_;
		const gchar* custom_icon_name = NULL;
		GFileInfo* _tmp1_;
		const gchar* _tmp2_;
		gboolean _tmp3_ = FALSE;
		const gchar* _tmp4_;
		const gchar* custom_icon = NULL;
		GFileInfo* _tmp8_;
		const gchar* _tmp9_;
		gboolean _tmp10_ = FALSE;
		const gchar* _tmp11_;
		const gchar* thumb_icon = NULL;
		GFileInfo* _tmp21_;
		const gchar* _tmp22_;
		gboolean _tmp23_ = FALSE;
		const gchar* _tmp24_;
		GFileInfo* _tmp28_;
		GIcon* _tmp29_;
		gchar* _tmp30_;
		_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_ICON "," PLANK_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON_NAME "," PLANK_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON "," G_FILE_ATTRIBUTE_THUMBNAIL_PATH, 0, NULL, &_inner_error_);
		info = _tmp0_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch14_g_error;
		}
		_tmp1_ = info;
		_tmp2_ = g_file_info_get_attribute_string (_tmp1_, PLANK_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON_NAME);
		custom_icon_name = _tmp2_;
		_tmp4_ = custom_icon_name;
		if (_tmp4_ != NULL) {
			const gchar* _tmp5_;
			_tmp5_ = custom_icon_name;
			_tmp3_ = g_strcmp0 (_tmp5_, "") != 0;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			const gchar* _tmp6_;
			gchar* _tmp7_;
			_tmp6_ = custom_icon_name;
			_tmp7_ = g_strdup (_tmp6_);
			result = _tmp7_;
			_g_object_unref0 (info);
			return result;
		}
		_tmp8_ = info;
		_tmp9_ = g_file_info_get_attribute_string (_tmp8_, PLANK_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON);
		custom_icon = _tmp9_;
		_tmp11_ = custom_icon;
		if (_tmp11_ != NULL) {
			const gchar* _tmp12_;
			_tmp12_ = custom_icon;
			_tmp10_ = g_strcmp0 (_tmp12_, "") != 0;
		} else {
			_tmp10_ = FALSE;
		}
		if (_tmp10_) {
			const gchar* _tmp13_;
			const gchar* _tmp16_;
			GFile* _tmp17_;
			GFile* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			_tmp13_ = custom_icon;
			if (g_str_has_prefix (_tmp13_, "file://")) {
				const gchar* _tmp14_;
				gchar* _tmp15_;
				_tmp14_ = custom_icon;
				_tmp15_ = g_strdup (_tmp14_);
				result = _tmp15_;
				_g_object_unref0 (info);
				return result;
			}
			_tmp16_ = custom_icon;
			_tmp17_ = g_file_get_child (file, _tmp16_);
			_tmp18_ = _tmp17_;
			_tmp19_ = g_file_get_path (_tmp18_);
			_tmp20_ = _tmp19_;
			_g_object_unref0 (_tmp18_);
			result = _tmp20_;
			_g_object_unref0 (info);
			return result;
		}
		_tmp21_ = info;
		_tmp22_ = g_file_info_get_attribute_byte_string (_tmp21_, G_FILE_ATTRIBUTE_THUMBNAIL_PATH);
		thumb_icon = _tmp22_;
		_tmp24_ = thumb_icon;
		if (_tmp24_ != NULL) {
			const gchar* _tmp25_;
			_tmp25_ = thumb_icon;
			_tmp23_ = g_strcmp0 (_tmp25_, "") != 0;
		} else {
			_tmp23_ = FALSE;
		}
		if (_tmp23_) {
			const gchar* _tmp26_;
			gchar* _tmp27_;
			_tmp26_ = thumb_icon;
			_tmp27_ = g_strdup (_tmp26_);
			result = _tmp27_;
			_g_object_unref0 (info);
			return result;
		}
		_tmp28_ = info;
		_tmp29_ = g_file_info_get_icon (_tmp28_);
		_tmp30_ = plank_drawing_service_get_icon_from_gicon (_tmp29_);
		result = _tmp30_;
		_g_object_unref0 (info);
		return result;
	}
	goto __finally14;
	__catch14_g_error:
	{
		gchar* _tmp31_ = NULL;
		gchar* _tmp32_;
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
		_tmp32_ = g_file_get_path (file);
		_tmp31_ = _tmp32_;
		if (_tmp31_ == NULL) {
			gchar* _tmp33_;
			_tmp33_ = g_strdup ("");
			_g_free0 (_tmp31_);
			_tmp31_ = _tmp33_;
		}
		g_debug ("DrawingService.vala:90: Could not get file info for '%s'", _tmp31_);
		_g_free0 (_tmp31_);
	}
	__finally14:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = NULL;
	return result;
}


/**
 * Gets an icon from a {@link GLib.Icon}.
 *
 * @param icon the icon to get the name for
 * @return the icon name, or null if none exists
 */
static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  int str_array_length1)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp20_;
		gint _tmp22_;
		gint _tmp23_;
		gsize _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		const gchar* res = NULL;
		gsize _tmp28_;
		void* _tmp29_;
		void* ptr = NULL;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		void* _tmp32_;
		const gchar* _tmp45_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp12_ = 0;
				gint _tmp13_;
				const gchar* _tmp14_;
				gsize _tmp19_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					gint _tmp8_;
					_tmp8_ = i;
					_tmp7_ = _tmp8_ < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp9_ = FALSE;
					if (str_array_length1 == -1) {
						gint _tmp10_;
						const gchar* _tmp11_;
						_tmp10_ = i;
						_tmp11_ = str_array[_tmp10_];
						_tmp9_ = _tmp11_ != NULL;
					} else {
						_tmp9_ = FALSE;
					}
					_tmp6_ = _tmp9_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp13_ = i;
				_tmp14_ = str_array[_tmp13_];
				if (_tmp14_ != NULL) {
					gint _tmp15_;
					const gchar* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					_tmp15_ = i;
					_tmp16_ = str_array[_tmp15_];
					_tmp17_ = strlen ((const gchar*) _tmp16_);
					_tmp18_ = _tmp17_;
					_tmp12_ = _tmp18_;
				} else {
					_tmp12_ = 0;
				}
				_tmp19_ = len;
				len = _tmp19_ + _tmp12_;
			}
		}
		_tmp20_ = i;
		if (_tmp20_ == 0) {
			gchar* _tmp21_;
			_tmp21_ = g_strdup ("");
			result = _tmp21_;
			return result;
		}
		_tmp22_ = i;
		str_array_length1 = _tmp22_;
		_tmp23_ = str_array_length1;
		_tmp24_ = len;
		_tmp25_ = strlen ((const gchar*) separator);
		_tmp26_ = _tmp25_;
		_tmp27_ = i;
		len = _tmp24_ + (_tmp26_ * (_tmp27_ - 1));
		_tmp28_ = len;
		_tmp29_ = g_malloc (_tmp28_);
		res = _tmp29_;
		_tmp30_ = res;
		_tmp31_ = str_array[0];
		_tmp32_ = g_stpcpy ((void*) _tmp30_, (const gchar*) _tmp31_);
		ptr = _tmp32_;
		{
			gboolean _tmp33_ = FALSE;
			i = 1;
			_tmp33_ = TRUE;
			while (TRUE) {
				gint _tmp35_;
				void* _tmp36_;
				void* _tmp37_;
				const gchar* _tmp38_ = NULL;
				gint _tmp39_;
				const gchar* _tmp40_;
				void* _tmp43_;
				void* _tmp44_;
				if (!_tmp33_) {
					gint _tmp34_;
					_tmp34_ = i;
					i = _tmp34_ + 1;
				}
				_tmp33_ = FALSE;
				_tmp35_ = i;
				if (!(_tmp35_ < str_array_length1)) {
					break;
				}
				_tmp36_ = ptr;
				_tmp37_ = g_stpcpy (_tmp36_, (const gchar*) separator);
				ptr = _tmp37_;
				_tmp39_ = i;
				_tmp40_ = str_array[_tmp39_];
				if (_tmp40_ != NULL) {
					gint _tmp41_;
					const gchar* _tmp42_;
					_tmp41_ = i;
					_tmp42_ = str_array[_tmp41_];
					_tmp38_ = (const gchar*) _tmp42_;
				} else {
					_tmp38_ = "";
				}
				_tmp43_ = ptr;
				_tmp44_ = g_stpcpy (_tmp43_, _tmp38_);
				ptr = _tmp44_;
			}
		}
		_tmp45_ = res;
		res = NULL;
		result = (gchar*) _tmp45_;
		return result;
	} else {
		gchar* _tmp46_;
		_tmp46_ = g_strdup ("");
		result = _tmp46_;
		return result;
	}
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch15_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch15_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally15;
	__catch15_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally15:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gchar*
plank_drawing_service_get_icon_from_gicon (GIcon* icon)
{
	gchar* result = NULL;
	if (G_TYPE_CHECK_INSTANCE_TYPE (icon, g_themed_icon_get_type ())) {
		gchar* icons = NULL;
		gchar** _tmp0_;
		gchar** _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp1_ = _tmp0_ = g_themed_icon_get_names (G_TYPE_CHECK_INSTANCE_CAST (icon, g_themed_icon_get_type (), GThemedIcon));
		_tmp2_ = _vala_g_strjoinv (";;", _tmp1_, _vala_array_length (_tmp0_));
		icons = _tmp2_;
		_tmp3_ = icons;
		_tmp4_ = string_replace (_tmp3_, "(null);;", "");
		result = _tmp4_;
		_g_free0 (icons);
		return result;
	}
	if (G_TYPE_CHECK_INSTANCE_TYPE (icon, g_file_icon_get_type ())) {
		GFile* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = g_file_icon_get_file (G_TYPE_CHECK_INSTANCE_CAST (icon, g_file_icon_get_type (), GFileIcon));
		_tmp6_ = g_file_get_path (_tmp5_);
		result = _tmp6_;
		return result;
	}
	result = NULL;
	return result;
}


/**
 * Loads an icon based on names and the given width/height
 *
 * @param names a delimited (with ";;") list of icon names, first one found is used
 * @param width the requested width of the icon
 * @param height the requested height of the icon
 * @return the pixbuf representing the requested icon
 */
static void
_vala_array_add3 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


GdkPixbuf*
plank_drawing_service_load_icon (const gchar* names,
                                 gint width,
                                 gint height)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	gchar** all_names = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint all_names_length1;
	gint _all_names_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GdkPixbuf* _tmp16_;
	GdkPixbuf* _tmp18_;
	GdkPixbuf* _tmp30_;
	g_return_val_if_fail (names != NULL, NULL);
	pbuf = NULL;
	_tmp1_ = _tmp0_ = g_strsplit (names, ";;", 0);
	all_names = _tmp1_;
	all_names_length1 = _vala_array_length (_tmp0_);
	_all_names_size_ = all_names_length1;
	_tmp2_ = all_names;
	_tmp2__length1 = all_names_length1;
	_tmp3_ = g_strdup (PLANK_DRAWING_SERVICE_DEFAULT_ICON);
	_vala_array_add3 (&all_names, &all_names_length1, &_all_names_size_, _tmp3_);
	_tmp4_ = all_names;
	_tmp4__length1 = all_names_length1;
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
		name_collection = _tmp4_;
		name_collection_length1 = _tmp4__length1;
		for (name_it = 0; name_it < _tmp4__length1; name_it = name_it + 1) {
			const gchar* name = NULL;
			name = name_collection[name_it];
			{
				GFile* file = NULL;
				const gchar* _tmp5_;
				GFile* _tmp6_;
				GFile* _tmp7_;
				const gchar* _tmp11_;
				GdkPixbuf* _tmp12_;
				GdkPixbuf* _tmp13_;
				const gchar* _tmp14_;
				_tmp5_ = name;
				_tmp6_ = plank_drawing_service_try_get_icon_file (_tmp5_);
				file = _tmp6_;
				_tmp7_ = file;
				if (_tmp7_ != NULL) {
					GFile* _tmp8_;
					GdkPixbuf* _tmp9_;
					GdkPixbuf* _tmp10_;
					_tmp8_ = file;
					_tmp9_ = plank_drawing_service_load_pixbuf_from_file (_tmp8_, width, height);
					_g_object_unref0 (pbuf);
					pbuf = _tmp9_;
					_tmp10_ = pbuf;
					if (_tmp10_ != NULL) {
						_g_object_unref0 (file);
						break;
					}
				}
				_tmp11_ = name;
				_tmp12_ = plank_drawing_service_load_pixbuf (_tmp11_, MAX (width, height));
				_g_object_unref0 (pbuf);
				pbuf = _tmp12_;
				_tmp13_ = pbuf;
				if (_tmp13_ != NULL) {
					_g_object_unref0 (file);
					break;
				}
				_tmp14_ = name;
				if (g_strcmp0 (_tmp14_, PLANK_DRAWING_SERVICE_DEFAULT_ICON) != 0) {
					const gchar* _tmp15_;
					_tmp15_ = name;
					g_message ("DrawingService.vala:144: Could not find icon '%s'", _tmp15_);
				}
				_g_object_unref0 (file);
			}
		}
	}
	_tmp16_ = pbuf;
	if (_tmp16_ == NULL) {
		GdkPixbuf* _tmp17_;
		_tmp17_ = plank_drawing_service_load_pixbuf_from_resource (PLANK_G_RESOURCE_PATH "/img/application-default-icon.svg", width, height);
		_g_object_unref0 (pbuf);
		pbuf = _tmp17_;
	}
	_tmp18_ = pbuf;
	if (_tmp18_ != NULL) {
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
		if (width != -1) {
			_tmp20_ = height != -1;
		} else {
			_tmp20_ = FALSE;
		}
		if (_tmp20_) {
			gboolean _tmp21_ = FALSE;
			GdkPixbuf* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
			_tmp22_ = pbuf;
			_tmp23_ = gdk_pixbuf_get_width (_tmp22_);
			_tmp24_ = _tmp23_;
			if (width != _tmp24_) {
				_tmp21_ = TRUE;
			} else {
				GdkPixbuf* _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
				_tmp25_ = pbuf;
				_tmp26_ = gdk_pixbuf_get_height (_tmp25_);
				_tmp27_ = _tmp26_;
				_tmp21_ = height != _tmp27_;
			}
			_tmp19_ = _tmp21_;
		} else {
			_tmp19_ = FALSE;
		}
		if (_tmp19_) {
			GdkPixbuf* _tmp28_;
			GdkPixbuf* _tmp29_;
			_tmp28_ = pbuf;
			_tmp29_ = plank_drawing_service_ar_scale (_tmp28_, width, height);
			result = _tmp29_;
			all_names = (_vala_array_free (all_names, all_names_length1, (GDestroyNotify) g_free), NULL);
			_g_object_unref0 (pbuf);
			return result;
		}
		result = pbuf;
		all_names = (_vala_array_free (all_names, all_names_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	g_warning ("DrawingService.vala:157: No icon found, return empty pixbuf");
	_tmp30_ = plank_drawing_service_get_empty_pixbuf (MAX (1, width), MAX (1, height));
	result = _tmp30_;
	all_names = (_vala_array_free (all_names, all_names_length1, (GDestroyNotify) g_free), NULL);
	_g_object_unref0 (pbuf);
	return result;
}


static GdkPixbuf*
plank_drawing_service_get_empty_pixbuf (gint width,
                                        gint height)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	GdkPixbuf* _tmp0_;
	_tmp0_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, width, height);
	pbuf = _tmp0_;
	gdk_pixbuf_fill (pbuf, (guint32) 0x00000000);
	result = pbuf;
	return result;
}


/**
 * Try to get a {@link GLib.File} for the given icon name
 *
 * @param name a string which might represent an existing file
 * @return a {@link GLib.File}, or null if it failed
 */
GFile*
plank_drawing_service_try_get_icon_file (const gchar* name)
{
	GFile* result = NULL;
	GFile* file = NULL;
	gchar* name_down = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp10_ = FALSE;
	GFile* _tmp11_;
	g_return_val_if_fail (name != NULL, NULL);
	file = NULL;
	_tmp0_ = g_utf8_strdown (name, (gssize) -1);
	name_down = _tmp0_;
	_tmp1_ = name_down;
	if (g_str_has_prefix (_tmp1_, "resource://")) {
		GFile* _tmp2_;
		_tmp2_ = g_file_new_for_uri (name);
		_g_object_unref0 (file);
		file = _tmp2_;
	} else {
		const gchar* _tmp3_;
		_tmp3_ = name_down;
		if (g_str_has_prefix (_tmp3_, "file://")) {
			GFile* _tmp4_;
			_tmp4_ = g_file_new_for_uri (name);
			_g_object_unref0 (file);
			file = _tmp4_;
		} else {
			if (g_str_has_prefix (name, "~/")) {
				const gchar* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				GFile* _tmp8_;
				_tmp5_ = g_get_home_dir ();
				_tmp6_ = string_replace (name, "~", _tmp5_);
				_tmp7_ = _tmp6_;
				_tmp8_ = g_file_new_for_path (_tmp7_);
				_g_object_unref0 (file);
				file = _tmp8_;
				_g_free0 (_tmp7_);
			} else {
				if (g_str_has_prefix (name, "/")) {
					GFile* _tmp9_;
					_tmp9_ = g_file_new_for_path (name);
					_g_object_unref0 (file);
					file = _tmp9_;
				}
			}
		}
	}
	_tmp11_ = file;
	if (_tmp11_ != NULL) {
		GFile* _tmp12_;
		_tmp12_ = file;
		_tmp10_ = g_file_query_exists (_tmp12_, NULL);
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		result = file;
		_g_free0 (name_down);
		return result;
	}
	result = NULL;
	_g_free0 (name_down);
	_g_object_unref0 (file);
	return result;
}


static GdkPixbuf*
plank_drawing_service_load_pixbuf_from_file (GFile* file,
                                             gint width,
                                             gint height)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	pbuf = NULL;
	{
		GFileInputStream* fis = NULL;
		GFileInputStream* _tmp0_;
		GdkPixbuf* _tmp1_ = NULL;
		GFileInputStream* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
		_tmp0_ = g_file_read (file, NULL, &_inner_error_);
		fis = _tmp0_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch16_g_error;
		}
		_tmp2_ = fis;
		_tmp3_ = gdk_pixbuf_new_from_stream_at_scale ((GInputStream*) _tmp2_, width, height, TRUE, NULL, &_inner_error_);
		_tmp1_ = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (fis);
			goto __catch16_g_error;
		}
		_tmp4_ = _tmp1_;
		_tmp1_ = NULL;
		_g_object_unref0 (pbuf);
		pbuf = _tmp4_;
		_g_object_unref0 (_tmp1_);
		_g_object_unref0 (fis);
	}
	goto __finally16;
	__catch16_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally16:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (pbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = pbuf;
	return result;
}


static GdkPixbuf*
plank_drawing_service_load_pixbuf_from_resource (const gchar* resource,
                                                 gint width,
                                                 gint height)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (resource != NULL, NULL);
	pbuf = NULL;
	{
		GdkPixbuf* _tmp0_ = NULL;
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_;
		_tmp1_ = gdk_pixbuf_new_from_resource_at_scale (resource, width, height, TRUE, &_inner_error_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch17_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (pbuf);
		pbuf = _tmp2_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally17;
	__catch17_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally17:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (pbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = pbuf;
	return result;
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}


static GdkPixbuf*
plank_drawing_service_load_pixbuf (const gchar* icon,
                                   gint size)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	GtkIconTheme* icon_theme = NULL;
	GtkIconTheme* _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (icon != NULL, NULL);
	pbuf = NULL;
	_tmp0_ = plank_drawing_service_get_icon_theme ();
	icon_theme = _tmp0_;
	g_mutex_lock (&plank_drawing_service_icon_theme_mutex);
	{
		GdkPixbuf* _tmp1_ = NULL;
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
		_tmp2_ = gtk_icon_theme_load_icon (icon_theme, icon, size, 0, &_inner_error_);
		_tmp1_ = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch18_g_error;
		}
		_tmp3_ = _tmp1_;
		_tmp1_ = NULL;
		_g_object_unref0 (pbuf);
		pbuf = _tmp3_;
		_g_object_unref0 (_tmp1_);
	}
	goto __finally18;
	__catch18_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally18:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (pbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	{
		gboolean _tmp4_ = FALSE;
		GdkPixbuf* _tmp5_;
		_tmp5_ = pbuf;
		if (_tmp5_ == NULL) {
			_tmp4_ = string_contains (icon, ".");
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			gchar** parts = NULL;
			gchar** _tmp6_;
			gchar** _tmp7_;
			gint parts_length1;
			gint _parts_size_;
			GdkPixbuf* _tmp8_ = NULL;
			gchar** _tmp9_;
			gint _tmp9__length1;
			const gchar* _tmp10_;
			GdkPixbuf* _tmp11_;
			GdkPixbuf* _tmp12_;
			_tmp7_ = _tmp6_ = g_strsplit (icon, ".", 0);
			parts = _tmp7_;
			parts_length1 = _vala_array_length (_tmp6_);
			_parts_size_ = parts_length1;
			_tmp9_ = parts;
			_tmp9__length1 = parts_length1;
			_tmp10_ = _tmp9_[0];
			_tmp11_ = gtk_icon_theme_load_icon (icon_theme, _tmp10_, size, 0, &_inner_error_);
			_tmp8_ = _tmp11_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
				goto __catch19_g_error;
			}
			_tmp12_ = _tmp8_;
			_tmp8_ = NULL;
			_g_object_unref0 (pbuf);
			pbuf = _tmp12_;
			_g_object_unref0 (_tmp8_);
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
		}
	}
	goto __finally19;
	__catch19_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally19:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (pbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	g_mutex_unlock (&plank_drawing_service_icon_theme_mutex);
	result = pbuf;
	return result;
}


/**
 * Loads an icon based on names and the given width/height
 *
 * @param names a delimited (with ";;") list of icon names, first one found is used
 * @param width the requested width of the icon
 * @param height the requested height of the icon
 * @param scale the implicit requested scale of the icon
 * @return the {link Cairo.Surface} containing the requested icon, do not alter this surface
 */
static void
_vala_array_add4 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


cairo_surface_t*
plank_drawing_service_load_icon_for_scale (const gchar* names,
                                           gint width,
                                           gint height,
                                           gint scale)
{
	cairo_surface_t* result = NULL;
	cairo_surface_t* surface = NULL;
	gchar** all_names = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint all_names_length1;
	gint _all_names_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	cairo_surface_t* _tmp29_;
	g_return_val_if_fail (names != NULL, NULL);
	surface = NULL;
	_tmp1_ = _tmp0_ = g_strsplit (names, ";;", 0);
	all_names = _tmp1_;
	all_names_length1 = _vala_array_length (_tmp0_);
	_all_names_size_ = all_names_length1;
	_tmp2_ = all_names;
	_tmp2__length1 = all_names_length1;
	_tmp3_ = g_strdup (PLANK_DRAWING_SERVICE_DEFAULT_ICON);
	_vala_array_add4 (&all_names, &all_names_length1, &_all_names_size_, _tmp3_);
	_tmp4_ = all_names;
	_tmp4__length1 = all_names_length1;
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
		name_collection = _tmp4_;
		name_collection_length1 = _tmp4__length1;
		for (name_it = 0; name_it < _tmp4__length1; name_it = name_it + 1) {
			const gchar* name = NULL;
			name = name_collection[name_it];
			{
				GFile* file = NULL;
				const gchar* _tmp5_;
				GFile* _tmp6_;
				GFile* _tmp7_;
				const gchar* _tmp24_;
				cairo_surface_t* _tmp25_;
				cairo_surface_t* _tmp26_;
				const gchar* _tmp27_;
				_tmp5_ = name;
				_tmp6_ = plank_drawing_service_try_get_icon_file (_tmp5_);
				file = _tmp6_;
				_tmp7_ = file;
				if (_tmp7_ != NULL) {
					GdkPixbuf* pbuf = NULL;
					GFile* _tmp8_;
					GdkPixbuf* _tmp9_;
					GdkPixbuf* _tmp10_;
					_tmp8_ = file;
					_tmp9_ = plank_drawing_service_load_pixbuf_from_file (_tmp8_, width, height);
					pbuf = _tmp9_;
					_tmp10_ = pbuf;
					if (_tmp10_ != NULL) {
						cairo_surface_t* _tmp11_;
						cairo_t* cr = NULL;
						cairo_surface_t* _tmp12_;
						cairo_t* _tmp13_;
						cairo_t* _tmp14_;
						GdkPixbuf* _tmp15_;
						GdkPixbuf* _tmp16_;
						gint _tmp17_;
						gint _tmp18_;
						GdkPixbuf* _tmp19_;
						gint _tmp20_;
						gint _tmp21_;
						cairo_t* _tmp22_;
						cairo_surface_t* _tmp23_;
						_tmp11_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
						_cairo_surface_destroy0 (surface);
						surface = _tmp11_;
						_tmp12_ = surface;
						_tmp13_ = cairo_create (_tmp12_);
						cr = _tmp13_;
						_tmp14_ = cr;
						_tmp15_ = pbuf;
						_tmp16_ = pbuf;
						_tmp17_ = gdk_pixbuf_get_width (_tmp16_);
						_tmp18_ = _tmp17_;
						_tmp19_ = pbuf;
						_tmp20_ = gdk_pixbuf_get_height (_tmp19_);
						_tmp21_ = _tmp20_;
						gdk_cairo_set_source_pixbuf (_tmp14_, _tmp15_, (gdouble) ((width - _tmp18_) / 2), (gdouble) ((height - _tmp21_) / 2));
						_tmp22_ = cr;
						cairo_paint (_tmp22_);
						_tmp23_ = surface;
						cairo_surface_set_device_scale (_tmp23_, (gdouble) scale, (gdouble) scale);
						_cairo_destroy0 (cr);
						_g_object_unref0 (pbuf);
						_g_object_unref0 (file);
						break;
					}
					_g_object_unref0 (pbuf);
				}
				_tmp24_ = name;
				_tmp25_ = plank_drawing_service_load_surface (_tmp24_, MAX (width, height) / scale, scale);
				_cairo_surface_destroy0 (surface);
				surface = _tmp25_;
				_tmp26_ = surface;
				if (_tmp26_ != NULL) {
					_g_object_unref0 (file);
					break;
				}
				_tmp27_ = name;
				if (g_strcmp0 (_tmp27_, PLANK_DRAWING_SERVICE_DEFAULT_ICON) != 0) {
					const gchar* _tmp28_;
					_tmp28_ = name;
					g_message ("DrawingService.vala:277: Could not find icon '%s'", _tmp28_);
				}
				_g_object_unref0 (file);
			}
		}
	}
	_tmp29_ = surface;
	if (_tmp29_ == NULL) {
		cairo_surface_t* _tmp30_;
		_tmp30_ = plank_drawing_service_load_surface_from_resource_at_scale (PLANK_G_RESOURCE_PATH "/img/application-default-icon.svg", width, height, scale);
		_cairo_surface_destroy0 (surface);
		surface = _tmp30_;
	}
	result = surface;
	all_names = (_vala_array_free (all_names, all_names_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static cairo_surface_t*
plank_drawing_service_load_surface_from_resource_at_scale (const gchar* resource,
                                                           gint width,
                                                           gint height,
                                                           gint scale)
{
	cairo_surface_t* result = NULL;
	GdkPixbuf* pbuf = NULL;
	cairo_surface_t* surface = NULL;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (resource != NULL, NULL);
	pbuf = NULL;
	surface = NULL;
	{
		GdkPixbuf* _tmp0_ = NULL;
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_;
		_tmp1_ = gdk_pixbuf_new_from_resource_at_scale (resource, width, height, TRUE, &_inner_error_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch20_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (pbuf);
		pbuf = _tmp2_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally20;
	__catch20_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally20:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_cairo_surface_destroy0 (surface);
		_g_object_unref0 (pbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp3_ = pbuf;
	if (_tmp3_ != NULL) {
		cairo_surface_t* _tmp4_;
		cairo_t* cr = NULL;
		cairo_surface_t* _tmp5_;
		cairo_t* _tmp6_;
		cairo_t* _tmp7_;
		GdkPixbuf* _tmp8_;
		GdkPixbuf* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		GdkPixbuf* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		cairo_t* _tmp15_;
		cairo_surface_t* _tmp16_;
		_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
		_cairo_surface_destroy0 (surface);
		surface = _tmp4_;
		_tmp5_ = surface;
		_tmp6_ = cairo_create (_tmp5_);
		cr = _tmp6_;
		_tmp7_ = cr;
		_tmp8_ = pbuf;
		_tmp9_ = pbuf;
		_tmp10_ = gdk_pixbuf_get_width (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = pbuf;
		_tmp13_ = gdk_pixbuf_get_height (_tmp12_);
		_tmp14_ = _tmp13_;
		gdk_cairo_set_source_pixbuf (_tmp7_, _tmp8_, (gdouble) ((width - _tmp11_) / 2), (gdouble) ((height - _tmp14_) / 2));
		_tmp15_ = cr;
		cairo_paint (_tmp15_);
		_tmp16_ = surface;
		cairo_surface_set_device_scale (_tmp16_, (gdouble) scale, (gdouble) scale);
		_cairo_destroy0 (cr);
	}
	result = surface;
	_g_object_unref0 (pbuf);
	return result;
}


static cairo_surface_t*
plank_drawing_service_load_surface (const gchar* icon,
                                    gint size,
                                    gint scale)
{
	cairo_surface_t* result = NULL;
	cairo_surface_t* surface = NULL;
	GtkIconInfo* info = NULL;
	GtkIconTheme* icon_theme = NULL;
	GtkIconTheme* _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (icon != NULL, NULL);
	surface = NULL;
	info = NULL;
	_tmp0_ = plank_drawing_service_get_icon_theme ();
	icon_theme = _tmp0_;
	g_mutex_lock (&plank_drawing_service_icon_theme_mutex);
	{
		GtkIconTheme* _tmp1_;
		GtkIconInfo* _tmp2_;
		GtkIconInfo* _tmp3_;
		_tmp1_ = icon_theme;
		_tmp2_ = gtk_icon_theme_lookup_icon_for_scale (_tmp1_, icon, size, scale, GTK_ICON_LOOKUP_FORCE_SIZE);
		_gtk_icon_info_free0 (info);
		info = _tmp2_;
		_tmp3_ = info;
		if (_tmp3_ != NULL) {
			cairo_surface_t* _tmp4_ = NULL;
			GtkIconInfo* _tmp5_;
			cairo_surface_t* _tmp6_;
			cairo_surface_t* _tmp7_;
			_tmp5_ = info;
			_tmp6_ = gtk_icon_info_load_surface (_tmp5_, NULL, &_inner_error_);
			_tmp4_ = _tmp6_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch21_g_error;
			}
			_tmp7_ = _tmp4_;
			_tmp4_ = NULL;
			_cairo_surface_destroy0 (surface);
			surface = _tmp7_;
			_cairo_surface_destroy0 (_tmp4_);
		}
	}
	goto __finally21;
	__catch21_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally21:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_gtk_icon_info_free0 (info);
		_cairo_surface_destroy0 (surface);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	{
		gboolean _tmp8_ = FALSE;
		cairo_surface_t* _tmp9_;
		_tmp9_ = surface;
		if (_tmp9_ == NULL) {
			_tmp8_ = string_contains (icon, ".");
		} else {
			_tmp8_ = FALSE;
		}
		if (_tmp8_) {
			gchar** parts = NULL;
			gchar** _tmp10_;
			gchar** _tmp11_;
			gint parts_length1;
			gint _parts_size_;
			GtkIconTheme* _tmp12_;
			gchar** _tmp13_;
			gint _tmp13__length1;
			const gchar* _tmp14_;
			GtkIconInfo* _tmp15_;
			GtkIconInfo* _tmp16_;
			_tmp11_ = _tmp10_ = g_strsplit (icon, ".", 0);
			parts = _tmp11_;
			parts_length1 = _vala_array_length (_tmp10_);
			_parts_size_ = parts_length1;
			_tmp12_ = icon_theme;
			_tmp13_ = parts;
			_tmp13__length1 = parts_length1;
			_tmp14_ = _tmp13_[0];
			_tmp15_ = gtk_icon_theme_lookup_icon_for_scale (_tmp12_, _tmp14_, size, scale, GTK_ICON_LOOKUP_FORCE_SIZE);
			_gtk_icon_info_free0 (info);
			info = _tmp15_;
			_tmp16_ = info;
			if (_tmp16_ != NULL) {
				cairo_surface_t* _tmp17_ = NULL;
				GtkIconInfo* _tmp18_;
				cairo_surface_t* _tmp19_;
				cairo_surface_t* _tmp20_;
				_tmp18_ = info;
				_tmp19_ = gtk_icon_info_load_surface (_tmp18_, NULL, &_inner_error_);
				_tmp17_ = _tmp19_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
					goto __catch22_g_error;
				}
				_tmp20_ = _tmp17_;
				_tmp17_ = NULL;
				_cairo_surface_destroy0 (surface);
				surface = _tmp20_;
				_cairo_surface_destroy0 (_tmp17_);
			}
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
		}
	}
	goto __finally22;
	__catch22_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally22:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_gtk_icon_info_free0 (info);
		_cairo_surface_destroy0 (surface);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	g_mutex_unlock (&plank_drawing_service_icon_theme_mutex);
	result = surface;
	_gtk_icon_info_free0 (info);
	return result;
}


/**
 * Scales a {@link Gdk.Pixbuf}, maintaining the original aspect ratio.
 *
 * @param source the pixbuf to scale
 * @param width the width of the scaled pixbuf
 * @param height the height of the scaled pixbuf
 * @return the scaled pixbuf
 */
GdkPixbuf*
plank_drawing_service_ar_scale (GdkPixbuf* source,
                                gint width,
                                gint height)
{
	GdkPixbuf* result = NULL;
	gdouble source_width = 0.0;
	gint _tmp0_;
	gint _tmp1_;
	gdouble source_height = 0.0;
	gint _tmp2_;
	gint _tmp3_;
	gdouble x_scale = 0.0;
	gdouble _tmp4_;
	gdouble y_scale = 0.0;
	gdouble _tmp5_;
	gdouble scale = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gint scaled_width = 0;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gint scaled_height = 0;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	GdkPixbuf* _tmp16_;
	g_return_val_if_fail (source != NULL, NULL);
	_tmp0_ = gdk_pixbuf_get_width (source);
	_tmp1_ = _tmp0_;
	source_width = (gdouble) _tmp1_;
	_tmp2_ = gdk_pixbuf_get_height (source);
	_tmp3_ = _tmp2_;
	source_height = (gdouble) _tmp3_;
	_tmp4_ = source_width;
	x_scale = width / _tmp4_;
	_tmp5_ = source_height;
	y_scale = height / _tmp5_;
	_tmp6_ = x_scale;
	_tmp7_ = y_scale;
	scale = MIN (_tmp6_, _tmp7_);
	_tmp8_ = scale;
	if (_tmp8_ == ((gdouble) 1)) {
		GdkPixbuf* _tmp9_;
		_tmp9_ = _g_object_ref0 (source);
		result = _tmp9_;
		return result;
	}
	_tmp10_ = source_width;
	_tmp11_ = scale;
	scaled_width = MAX (1, (gint) (_tmp10_ * _tmp11_));
	_tmp12_ = source_height;
	_tmp13_ = scale;
	scaled_height = MAX (1, (gint) (_tmp12_ * _tmp13_));
	_tmp14_ = scaled_width;
	_tmp15_ = scaled_height;
	_tmp16_ = gdk_pixbuf_scale_simple (source, _tmp14_, _tmp15_, GDK_INTERP_HYPER);
	result = _tmp16_;
	return result;
}


/**
 * Computes and returns the average color of a {@link Gdk.Pixbuf}.
 * The resulting color is the average of all pixels which aren't
 * nearly transparent while saturated pixels are weighted more than
 * "grey" ones.
 *
 * @param source the pixbuf to use
 * @return the average color of the pixbuf
 */
void
plank_drawing_service_average_color (GdkPixbuf* source,
                                     PlankColor* result)
{
	guint8 r = 0U;
	guint8 g = 0U;
	guint8 b = 0U;
	guint8 a = 0U;
	guint8 min = 0U;
	guint8 max = 0U;
	gdouble delta = 0.0;
	gdouble rTotal = 0.0;
	gdouble gTotal = 0.0;
	gdouble bTotal = 0.0;
	gdouble bTotal2 = 0.0;
	gdouble gTotal2 = 0.0;
	gdouble rTotal2 = 0.0;
	gdouble aTotal2 = 0.0;
	guint8* dataPtr = NULL;
	guint8* _tmp0_;
	gint n_channels = 0;
	gint _tmp1_;
	gint _tmp2_;
	gint width = 0;
	gint _tmp3_;
	gint _tmp4_;
	gint height = 0;
	gint _tmp5_;
	gint _tmp6_;
	gint rowstride = 0;
	gint _tmp7_;
	gint _tmp8_;
	gint length = 0;
	gint _tmp9_;
	gint _tmp10_;
	gint pixels = 0;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gdouble scoreTotal = 0.0;
	gint _tmp66_;
	gdouble _tmp68_;
	gint _tmp69_;
	gdouble _tmp70_;
	gint _tmp71_;
	gdouble _tmp72_;
	gint _tmp73_;
	gdouble _tmp74_;
	gint _tmp75_;
	gdouble _tmp76_;
	gdouble _tmp83_;
	gint _tmp84_;
	gdouble _tmp85_;
	gint _tmp86_;
	gdouble _tmp87_;
	gint _tmp88_;
	gdouble _tmp89_;
	gint _tmp90_;
	gdouble _tmp91_;
	gdouble max_val = 0.0;
	gdouble _tmp106_;
	gdouble _tmp107_;
	gdouble _tmp108_;
	gdouble _tmp109_;
	gdouble _tmp116_;
	gdouble _tmp117_;
	gdouble _tmp118_;
	gdouble _tmp119_;
	PlankColor _tmp120_ = {0};
	g_return_if_fail (source != NULL);
	rTotal = 0.0;
	gTotal = 0.0;
	bTotal = 0.0;
	bTotal2 = 0.0;
	gTotal2 = 0.0;
	rTotal2 = 0.0;
	aTotal2 = 0.0;
	_tmp0_ = gdk_pixbuf_get_pixels (source);
	dataPtr = _tmp0_;
	_tmp1_ = gdk_pixbuf_get_n_channels (source);
	_tmp2_ = _tmp1_;
	n_channels = _tmp2_;
	_tmp3_ = gdk_pixbuf_get_width (source);
	_tmp4_ = _tmp3_;
	width = _tmp4_;
	_tmp5_ = gdk_pixbuf_get_height (source);
	_tmp6_ = _tmp5_;
	height = _tmp6_;
	_tmp7_ = gdk_pixbuf_get_rowstride (source);
	_tmp8_ = _tmp7_;
	rowstride = _tmp8_;
	_tmp9_ = width;
	_tmp10_ = height;
	length = _tmp9_ * _tmp10_;
	_tmp11_ = height;
	_tmp12_ = rowstride;
	_tmp13_ = n_channels;
	pixels = (_tmp11_ * _tmp12_) / _tmp13_;
	scoreTotal = 0.0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp14_ = FALSE;
			_tmp14_ = TRUE;
			while (TRUE) {
				gint _tmp16_;
				gint _tmp17_;
				guint8* _tmp18_;
				guint8 _tmp19_;
				guint8* _tmp20_;
				guint8 _tmp21_;
				guint8* _tmp22_;
				guint8 _tmp23_;
				guint8* _tmp24_;
				guint8 _tmp25_;
				guint8 _tmp26_;
				guint8 _tmp30_;
				guint8 _tmp31_;
				guint8 _tmp32_;
				guint8 _tmp33_;
				guint8 _tmp34_;
				guint8 _tmp35_;
				guint8 _tmp36_;
				guint8 _tmp37_;
				gdouble _tmp38_ = 0.0;
				gdouble _tmp39_;
				gdouble score = 0.0;
				gdouble _tmp42_;
				gdouble _tmp43_;
				guint8 _tmp44_;
				guint8 _tmp45_;
				gdouble _tmp46_;
				gdouble _tmp47_;
				guint8 _tmp48_;
				guint8 _tmp49_;
				gdouble _tmp50_;
				gdouble _tmp51_;
				guint8 _tmp52_;
				guint8 _tmp53_;
				gdouble _tmp54_;
				gdouble _tmp55_;
				gdouble _tmp56_;
				guint8 _tmp57_;
				gdouble _tmp58_;
				guint8 _tmp59_;
				gdouble _tmp60_;
				guint8 _tmp61_;
				gdouble _tmp62_;
				guint8 _tmp63_;
				guint8* _tmp64_;
				gint _tmp65_;
				if (!_tmp14_) {
					gint _tmp15_;
					_tmp15_ = i;
					i = _tmp15_ + 1;
				}
				_tmp14_ = FALSE;
				_tmp16_ = i;
				_tmp17_ = pixels;
				if (!(_tmp16_ < _tmp17_)) {
					break;
				}
				_tmp18_ = dataPtr;
				_tmp19_ = _tmp18_[0];
				r = _tmp19_;
				_tmp20_ = dataPtr;
				_tmp21_ = _tmp20_[1];
				g = _tmp21_;
				_tmp22_ = dataPtr;
				_tmp23_ = _tmp22_[2];
				b = _tmp23_;
				_tmp24_ = dataPtr;
				_tmp25_ = _tmp24_[3];
				a = _tmp25_;
				_tmp26_ = a;
				if (_tmp26_ <= PLANK_DRAWING_SERVICE_ALPHA_THRESHOLD) {
					gint _tmp27_;
					guint8* _tmp28_;
					gint _tmp29_;
					_tmp27_ = length;
					length = _tmp27_ - 1;
					_tmp28_ = dataPtr;
					_tmp29_ = n_channels;
					dataPtr = _tmp28_ + _tmp29_;
					continue;
				}
				_tmp30_ = r;
				_tmp31_ = g;
				_tmp32_ = b;
				min = MIN (_tmp30_, MIN (_tmp31_, _tmp32_));
				_tmp33_ = r;
				_tmp34_ = g;
				_tmp35_ = b;
				max = MAX (_tmp33_, MAX (_tmp34_, _tmp35_));
				_tmp36_ = max;
				_tmp37_ = min;
				delta = (gdouble) (_tmp36_ - _tmp37_);
				_tmp39_ = delta;
				if (_tmp39_ == ((gdouble) 0)) {
					_tmp38_ = 0.0;
				} else {
					gdouble _tmp40_;
					guint8 _tmp41_;
					_tmp40_ = delta;
					_tmp41_ = max;
					_tmp38_ = _tmp40_ / _tmp41_;
				}
				score = PLANK_DRAWING_SERVICE_SATURATION_WEIGHT * _tmp38_;
				_tmp42_ = bTotal;
				_tmp43_ = score;
				_tmp44_ = b;
				_tmp45_ = a;
				bTotal = _tmp42_ + ((_tmp43_ * _tmp44_) / _tmp45_);
				_tmp46_ = gTotal;
				_tmp47_ = score;
				_tmp48_ = g;
				_tmp49_ = a;
				gTotal = _tmp46_ + ((_tmp47_ * _tmp48_) / _tmp49_);
				_tmp50_ = rTotal;
				_tmp51_ = score;
				_tmp52_ = r;
				_tmp53_ = a;
				rTotal = _tmp50_ + ((_tmp51_ * _tmp52_) / _tmp53_);
				_tmp54_ = scoreTotal;
				_tmp55_ = score;
				scoreTotal = _tmp54_ + _tmp55_;
				_tmp56_ = bTotal2;
				_tmp57_ = b;
				bTotal2 = _tmp56_ + _tmp57_;
				_tmp58_ = gTotal2;
				_tmp59_ = g;
				gTotal2 = _tmp58_ + _tmp59_;
				_tmp60_ = rTotal2;
				_tmp61_ = r;
				rTotal2 = _tmp60_ + _tmp61_;
				_tmp62_ = aTotal2;
				_tmp63_ = a;
				aTotal2 = _tmp62_ + _tmp63_;
				_tmp64_ = dataPtr;
				_tmp65_ = n_channels;
				dataPtr = _tmp64_ + _tmp65_;
			}
		}
	}
	_tmp66_ = length;
	if (_tmp66_ <= 0) {
		PlankColor _tmp67_ = {0};
		_tmp67_.red = 0.0;
		_tmp67_.green = 0.0;
		_tmp67_.blue = 0.0;
		_tmp67_.alpha = 0.0;
		*result = _tmp67_;
		return;
	}
	_tmp68_ = scoreTotal;
	_tmp69_ = length;
	scoreTotal = _tmp68_ / _tmp69_;
	_tmp70_ = bTotal;
	_tmp71_ = length;
	bTotal = _tmp70_ / _tmp71_;
	_tmp72_ = gTotal;
	_tmp73_ = length;
	gTotal = _tmp72_ / _tmp73_;
	_tmp74_ = rTotal;
	_tmp75_ = length;
	rTotal = _tmp74_ / _tmp75_;
	_tmp76_ = scoreTotal;
	if (_tmp76_ > 0.0) {
		gdouble _tmp77_;
		gdouble _tmp78_;
		gdouble _tmp79_;
		gdouble _tmp80_;
		gdouble _tmp81_;
		gdouble _tmp82_;
		_tmp77_ = bTotal;
		_tmp78_ = scoreTotal;
		bTotal = _tmp77_ / _tmp78_;
		_tmp79_ = gTotal;
		_tmp80_ = scoreTotal;
		gTotal = _tmp79_ / _tmp80_;
		_tmp81_ = rTotal;
		_tmp82_ = scoreTotal;
		rTotal = _tmp81_ / _tmp82_;
	}
	_tmp83_ = bTotal2;
	_tmp84_ = length;
	bTotal2 = _tmp83_ / (_tmp84_ * G_MAXUINT8);
	_tmp85_ = gTotal2;
	_tmp86_ = length;
	gTotal2 = _tmp85_ / (_tmp86_ * G_MAXUINT8);
	_tmp87_ = rTotal2;
	_tmp88_ = length;
	rTotal2 = _tmp87_ / (_tmp88_ * G_MAXUINT8);
	_tmp89_ = aTotal2;
	_tmp90_ = length;
	aTotal2 = _tmp89_ / (_tmp90_ * G_MAXUINT8);
	_tmp91_ = scoreTotal;
	if (_tmp91_ <= PLANK_DRAWING_SERVICE_WEIGHT_THRESHOLD) {
		gdouble f = 0.0;
		gdouble _tmp92_;
		gdouble rf = 0.0;
		gdouble _tmp93_;
		gdouble _tmp94_;
		gdouble _tmp95_;
		gdouble _tmp96_;
		gdouble _tmp97_;
		gdouble _tmp98_;
		gdouble _tmp99_;
		gdouble _tmp100_;
		gdouble _tmp101_;
		gdouble _tmp102_;
		gdouble _tmp103_;
		gdouble _tmp104_;
		gdouble _tmp105_;
		_tmp92_ = scoreTotal;
		f = (1.0 / PLANK_DRAWING_SERVICE_WEIGHT_THRESHOLD) * _tmp92_;
		_tmp93_ = f;
		rf = 1.0 - _tmp93_;
		_tmp94_ = bTotal;
		_tmp95_ = f;
		_tmp96_ = bTotal2;
		_tmp97_ = rf;
		bTotal = (_tmp94_ * _tmp95_) + (_tmp96_ * _tmp97_);
		_tmp98_ = gTotal;
		_tmp99_ = f;
		_tmp100_ = gTotal2;
		_tmp101_ = rf;
		gTotal = (_tmp98_ * _tmp99_) + (_tmp100_ * _tmp101_);
		_tmp102_ = rTotal;
		_tmp103_ = f;
		_tmp104_ = rTotal2;
		_tmp105_ = rf;
		rTotal = (_tmp102_ * _tmp103_) + (_tmp104_ * _tmp105_);
	}
	_tmp106_ = rTotal;
	_tmp107_ = gTotal;
	_tmp108_ = bTotal;
	max_val = MAX (_tmp106_, MAX (_tmp107_, _tmp108_));
	_tmp109_ = max_val;
	if (_tmp109_ > 1.0) {
		gdouble _tmp110_;
		gdouble _tmp111_;
		gdouble _tmp112_;
		gdouble _tmp113_;
		gdouble _tmp114_;
		gdouble _tmp115_;
		_tmp110_ = bTotal;
		_tmp111_ = max_val;
		bTotal = _tmp110_ / _tmp111_;
		_tmp112_ = gTotal;
		_tmp113_ = max_val;
		gTotal = _tmp112_ / _tmp113_;
		_tmp114_ = rTotal;
		_tmp115_ = max_val;
		rTotal = _tmp114_ / _tmp115_;
	}
	_tmp116_ = rTotal;
	_tmp117_ = gTotal;
	_tmp118_ = bTotal;
	_tmp119_ = aTotal2;
	_tmp120_.red = _tmp116_;
	_tmp120_.green = _tmp117_;
	_tmp120_.blue = _tmp118_;
	_tmp120_.alpha = _tmp119_;
	*result = _tmp120_;
	return;
}


static void
plank_drawing_service_class_init (PlankDrawingServiceClass * klass)
{
	plank_drawing_service_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = plank_drawing_service_finalize;
}


static void
plank_drawing_service_instance_init (PlankDrawingService * self)
{
}


static void
plank_drawing_service_finalize (GObject * obj)
{
	PlankDrawingService * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DRAWING_SERVICE, PlankDrawingService);
	G_OBJECT_CLASS (plank_drawing_service_parent_class)->finalize (obj);
}


/**
 * Utility service for loading icons and working with pixbufs.
 */
GType
plank_drawing_service_get_type (void)
{
	static volatile gsize plank_drawing_service_type_id__volatile = 0;
	if (g_once_init_enter (&plank_drawing_service_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankDrawingServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_drawing_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDrawingService), 0, (GInstanceInitFunc) plank_drawing_service_instance_init, NULL };
		GType plank_drawing_service_type_id;
		plank_drawing_service_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankDrawingService", &g_define_type_info, 0);
		g_once_init_leave (&plank_drawing_service_type_id__volatile, plank_drawing_service_type_id);
	}
	return plank_drawing_service_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



