/* Surface.c generated by valac 0.39.7, the Vala compiler
 * generated from Surface.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <string.h>


#define PLANK_TYPE_SURFACE (plank_surface_get_type ())
#define PLANK_SURFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_SURFACE, PlankSurface))
#define PLANK_SURFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_SURFACE, PlankSurfaceClass))
#define PLANK_IS_SURFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_SURFACE))
#define PLANK_IS_SURFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_SURFACE))
#define PLANK_SURFACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_SURFACE, PlankSurfaceClass))

typedef struct _PlankSurface PlankSurface;
typedef struct _PlankSurfaceClass PlankSurfaceClass;
typedef struct _PlankSurfacePrivate PlankSurfacePrivate;
enum  {
	PLANK_SURFACE_0_PROPERTY,
	PLANK_SURFACE_INTERNAL_PROPERTY,
	PLANK_SURFACE_WIDTH_PROPERTY,
	PLANK_SURFACE_HEIGHT_PROPERTY,
	PLANK_SURFACE_CONTEXT_PROPERTY,
	PLANK_SURFACE_NUM_PROPERTIES
};
static GParamSpec* plank_surface_properties[PLANK_SURFACE_NUM_PROPERTIES];
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define PLANK_TYPE_COLOR (plank_color_get_type ())
typedef GdkRGBA PlankColor;
typedef struct _Block5Data Block5Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _Block6Data Block6Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PlankSurface {
	GObject parent_instance;
	PlankSurfacePrivate * priv;
};

struct _PlankSurfaceClass {
	GObjectClass parent_class;
};

struct _PlankSurfacePrivate {
	cairo_surface_t* _Internal;
	gint _Width;
	gint _Height;
	cairo_t* _Context;
};

struct _Block5Data {
	int _ref_count_;
	PlankSurface* self;
	gint alpha;
	gint height;
	gint width;
	guint8* pixels;
};

struct _Block6Data {
	int _ref_count_;
	PlankSurface* self;
	gint gaussWidth;
	gdouble* kernel;
	gint kernel_length1;
	gint _kernel_size_;
	gint width;
	gint height;
	gdouble* abuffer;
	gint abuffer_length1;
	gint _abuffer_size_;
	gdouble* bbuffer;
	gint bbuffer_length1;
	gint _bbuffer_size_;
	gint* shiftar;
	gint shiftar_length1;
	gint shiftar_length2;
	gint _shiftar_size_;
};


static gpointer plank_surface_parent_class = NULL;

GType plank_surface_get_type (void) G_GNUC_CONST;
#define PLANK_SURFACE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PLANK_TYPE_SURFACE, PlankSurfacePrivate))
#define PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION 16
#define PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION 7
PlankSurface* plank_surface_new (gint width,
                                 gint height);
PlankSurface* plank_surface_construct (GType object_type,
                                       gint width,
                                       gint height);
PlankSurface* plank_surface_new_with_cairo_surface (gint width,
                                                    gint height,
                                                    cairo_surface_t* model);
PlankSurface* plank_surface_construct_with_cairo_surface (GType object_type,
                                                          gint width,
                                                          gint height,
                                                          cairo_surface_t* model);
PlankSurface* plank_surface_new_with_surface (gint width,
                                              gint height,
                                              PlankSurface* model);
PlankSurface* plank_surface_construct_with_surface (GType object_type,
                                                    gint width,
                                                    gint height,
                                                    PlankSurface* model);
cairo_surface_t* plank_surface_get_Internal (PlankSurface* self);
PlankSurface* plank_surface_new_with_internal (cairo_surface_t* image);
PlankSurface* plank_surface_construct_with_internal (GType object_type,
                                                     cairo_surface_t* image);
void plank_surface_clear (PlankSurface* self);
cairo_t* plank_surface_get_Context (PlankSurface* self);
PlankSurface* plank_surface_copy (PlankSurface* self);
gint plank_surface_get_Width (PlankSurface* self);
gint plank_surface_get_Height (PlankSurface* self);
PlankSurface* plank_surface_scaled_copy (PlankSurface* self,
                                         gint width,
                                         gint height);
GdkPixbuf* plank_surface_to_pixbuf (PlankSurface* self);
PlankSurface* plank_surface_create_mask (PlankSurface* self,
                                         gdouble threshold,
                                         GdkRectangle* extent);
GType plank_color_get_type (void) G_GNUC_CONST;
PlankColor* plank_color_dup (const PlankColor* self);
void plank_color_free (PlankColor* self);
void plank_surface_average_color (PlankSurface* self,
                                  PlankColor* result);
void plank_drawing_service_average_color (GdkPixbuf* source,
                                          PlankColor* result);
void plank_surface_fast_blur (PlankSurface* self,
                              gint radius,
                              gint process_count);
void plank_surface_exponential_blur (PlankSurface* self,
                                     gint radius);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void* __lambda4_ (Block5Data* _data5_);
static void plank_surface_exponential_blur_rows (guint8* pixels,
                                          gint width,
                                          gint height,
                                          gint startRow,
                                          gint endRow,
                                          gint startX,
                                          gint endX,
                                          gint alpha);
static gpointer ___lambda4__gthread_func (gpointer self);
static void* __lambda5_ (Block5Data* _data5_);
static void plank_surface_exponential_blur_columns (guint8* pixels,
                                             gint width,
                                             gint height,
                                             gint startCol,
                                             gint endCol,
                                             gint startY,
                                             gint endY,
                                             gint alpha);
static gpointer ___lambda5__gthread_func (gpointer self);
static inline void plank_surface_exponential_blur_inner (guint8* pixel,
                                           gint* zA,
                                           gint* zR,
                                           gint* zG,
                                           gint* zB,
                                           gint alpha);
void plank_surface_gaussian_blur (PlankSurface* self,
                                  gint radius);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gdouble* plank_surface_build_gaussian_kernel (gint gaussWidth,
                                              int* result_length1);
static void* __lambda6_ (Block6Data* _data6_);
static void plank_surface_gaussian_blur_horizontal (gdouble* src,
                                             gdouble* dest,
                                             gdouble* kernel,
                                             gint gaussWidth,
                                             gint width,
                                             gint height,
                                             gint startRow,
                                             gint endRow,
                                             gint* shift,
                                             int shift_length1,
                                             int shift_length2);
static gpointer ___lambda6__gthread_func (gpointer self);
static void* __lambda7_ (Block6Data* _data6_);
static void plank_surface_gaussian_blur_vertical (gdouble* src,
                                           gdouble* dest,
                                           gdouble* kernel,
                                           gint gaussWidth,
                                           gint width,
                                           gint height,
                                           gint startCol,
                                           gint endCol,
                                           gint* shift,
                                           int shift_length1,
                                           int shift_length2);
static gpointer ___lambda7__gthread_func (gpointer self);
static void plank_surface_set_Internal (PlankSurface* self,
                                 cairo_surface_t* value);
static void plank_surface_set_Width (PlankSurface* self,
                              gint value);
static void plank_surface_set_Height (PlankSurface* self,
                               gint value);
static void plank_surface_set_Context (PlankSurface* self,
                                cairo_t* value);
static GObject * plank_surface_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void plank_surface_finalize (GObject * obj);
static void _vala_plank_surface_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_plank_surface_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);


/**
 * Creates a new surface.
 *
 * @param width width of the new surface
 * @param height height of the new surface
 */
PlankSurface*
plank_surface_construct (GType object_type,
                         gint width,
                         gint height)
{
	PlankSurface * self = NULL;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	_tmp0_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
	_tmp1_ = _tmp0_;
	self = (PlankSurface*) g_object_new (object_type, "Width", width, "Height", height, "Internal", _tmp1_, NULL);
	_cairo_surface_destroy0 (_tmp1_);
	return self;
}


PlankSurface*
plank_surface_new (gint width,
                   gint height)
{
	return plank_surface_construct (PLANK_TYPE_SURFACE, width, height);
}


/**
 * Creates a new surface compatible with an existing {@link Cairo.Surface}.
 *
 * @param width width of the new surface
 * @param height height of the new surface
 * @param model existing {@link Cairo.Surface} to be similar to
 */
PlankSurface*
plank_surface_construct_with_cairo_surface (GType object_type,
                                            gint width,
                                            gint height,
                                            cairo_surface_t* model)
{
	PlankSurface * self = NULL;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	g_return_val_if_fail (model != NULL, NULL);
	_tmp0_ = cairo_surface_create_similar (model, CAIRO_CONTENT_COLOR_ALPHA, width, height);
	_tmp1_ = _tmp0_;
	self = (PlankSurface*) g_object_new (object_type, "Width", width, "Height", height, "Internal", _tmp1_, NULL);
	_cairo_surface_destroy0 (_tmp1_);
	return self;
}


PlankSurface*
plank_surface_new_with_cairo_surface (gint width,
                                      gint height,
                                      cairo_surface_t* model)
{
	return plank_surface_construct_with_cairo_surface (PLANK_TYPE_SURFACE, width, height, model);
}


/**
 * Creates a new surface compatible with an existing {@link Surface}.
 *
 * @param width width of the new surface
 * @param height height of the new surface
 * @param model existing {@link Surface} to be similar to
 */
PlankSurface*
plank_surface_construct_with_surface (GType object_type,
                                      gint width,
                                      gint height,
                                      PlankSurface* model)
{
	PlankSurface * self = NULL;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* _tmp2_;
	g_return_val_if_fail (model != NULL, NULL);
	_tmp0_ = model->priv->_Internal;
	_tmp1_ = cairo_surface_create_similar (_tmp0_, CAIRO_CONTENT_COLOR_ALPHA, width, height);
	_tmp2_ = _tmp1_;
	self = (PlankSurface*) g_object_new (object_type, "Width", width, "Height", height, "Internal", _tmp2_, NULL);
	_cairo_surface_destroy0 (_tmp2_);
	return self;
}


PlankSurface*
plank_surface_new_with_surface (gint width,
                                gint height,
                                PlankSurface* model)
{
	return plank_surface_construct_with_surface (PLANK_TYPE_SURFACE, width, height, model);
}


/**
 * Creates a new surface with the given {@link Cairo.ImageSurface} as Internal.
 *
 * @param image existing {@link Cairo.ImageSurface} as Internal
 */
PlankSurface*
plank_surface_construct_with_internal (GType object_type,
                                       cairo_surface_t* image)
{
	PlankSurface * self = NULL;
	g_return_val_if_fail (image != NULL, NULL);
	self = (PlankSurface*) g_object_new (object_type, "Width", cairo_image_surface_get_width (image), "Height", cairo_image_surface_get_height (image), "Internal", image, NULL);
	return self;
}


PlankSurface*
plank_surface_new_with_internal (cairo_surface_t* image)
{
	return plank_surface_construct_with_internal (PLANK_TYPE_SURFACE, image);
}


/**
 * Clears the entire surface.
 */
void
plank_surface_clear (PlankSurface* self)
{
	cairo_t* cr = NULL;
	cairo_t* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_Context;
	cr = _tmp0_;
	cairo_save (cr);
	cairo_set_operator (cr, CAIRO_OPERATOR_CLEAR);
	cairo_paint (cr);
	cairo_restore (cr);
}


/**
 * Create a copy of the surface
 *
 * @return copy of this surface
 */
PlankSurface*
plank_surface_copy (PlankSurface* self)
{
	PlankSurface* result = NULL;
	PlankSurface* copy = NULL;
	gint _tmp0_;
	gint _tmp1_;
	PlankSurface* _tmp2_;
	cairo_t* cr = NULL;
	cairo_t* _tmp3_;
	cairo_surface_t* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Width;
	_tmp1_ = self->priv->_Height;
	_tmp2_ = plank_surface_new_with_surface (_tmp0_, _tmp1_, self);
	copy = _tmp2_;
	_tmp3_ = copy->priv->_Context;
	cr = _tmp3_;
	_tmp4_ = self->priv->_Internal;
	cairo_set_source_surface (cr, _tmp4_, (gdouble) 0, (gdouble) 0);
	cairo_paint (cr);
	result = copy;
	return result;
}


/**
 * Create a scaled copy of the surface
 *
 * @param width the resulting width
 * @param height the resulting height
 * @return scaled copy of this surface
 */
PlankSurface*
plank_surface_scaled_copy (PlankSurface* self,
                           gint width,
                           gint height)
{
	PlankSurface* result = NULL;
	PlankSurface* _result_ = NULL;
	PlankSurface* _tmp0_;
	cairo_t* cr = NULL;
	cairo_t* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	cairo_surface_t* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = plank_surface_new_with_surface (width, height, self);
	_result_ = _tmp0_;
	_tmp1_ = _result_->priv->_Context;
	cr = _tmp1_;
	cairo_save (cr);
	_tmp2_ = self->priv->_Width;
	_tmp3_ = self->priv->_Height;
	cairo_scale (cr, ((gdouble) width) / _tmp2_, ((gdouble) height) / _tmp3_);
	_tmp4_ = self->priv->_Internal;
	cairo_set_source_surface (cr, _tmp4_, (gdouble) 0, (gdouble) 0);
	cairo_paint (cr);
	cairo_restore (cr);
	result = _result_;
	return result;
}


/**
 * Saves the current surface to a {@link Gdk.Pixbuf}.
 *
 * @return the {@link Gdk.Pixbuf}
 */
GdkPixbuf*
plank_surface_to_pixbuf (PlankSurface* self)
{
	GdkPixbuf* result = NULL;
	cairo_surface_t* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GdkPixbuf* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Internal;
	_tmp1_ = self->priv->_Width;
	_tmp2_ = self->priv->_Height;
	_tmp3_ = gdk_pixbuf_get_from_surface (_tmp0_, 0, 0, _tmp1_, _tmp2_);
	result = _tmp3_;
	return result;
}


/**
 * Computes the mask of the surface.
 *
 * @param threshold value defining the minimum opacity [0.0 .. 1.0]
 * @param extent bounding box of the found mask
 * @return a new surface containing the mask
 */
PlankSurface*
plank_surface_create_mask (PlankSurface* self,
                           gdouble threshold,
                           GdkRectangle* extent)
{
	GdkRectangle _vala_extent = {0};
	PlankSurface* result = NULL;
	cairo_surface_t* surface = NULL;
	gint _tmp0_;
	gint _tmp1_;
	cairo_surface_t* _tmp2_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp3_;
	cairo_t* _tmp4_;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_surface_t* _tmp7_;
	cairo_t* _tmp8_;
	gint w = 0;
	cairo_surface_t* _tmp9_;
	gint h = 0;
	cairo_surface_t* _tmp10_;
	guint8 slice = 0U;
	gint left = 0;
	gint _tmp11_;
	gint right = 0;
	gint top = 0;
	gint _tmp12_;
	gint bottom = 0;
	guint8* data = NULL;
	cairo_surface_t* _tmp13_;
	guchar* _tmp14_;
	gint src = 0;
	gboolean mask = FALSE;
	gint _tmp57_;
	gint _tmp58_;
	gint _tmp59_;
	gint _tmp60_;
	gint _tmp61_;
	gint _tmp62_;
	GdkRectangle _tmp63_ = {0};
	cairo_surface_t* _tmp64_;
	PlankSurface* _tmp65_;
	g_return_val_if_fail (self != NULL, NULL);
	_vala_return_val_if_fail ((threshold >= 0.0) && (threshold <= 1.0), "threshold >= 0.0 && threshold <= 1.0", NULL);
	_tmp0_ = self->priv->_Width;
	_tmp1_ = self->priv->_Height;
	_tmp2_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp0_, _tmp1_);
	surface = _tmp2_;
	_tmp3_ = surface;
	_tmp4_ = cairo_create (_tmp3_);
	cr = _tmp4_;
	_tmp5_ = cr;
	cairo_set_operator (_tmp5_, CAIRO_OPERATOR_SOURCE);
	_tmp6_ = cr;
	_tmp7_ = self->priv->_Internal;
	cairo_set_source_surface (_tmp6_, _tmp7_, (gdouble) 0, (gdouble) 0);
	_tmp8_ = cr;
	cairo_paint (_tmp8_);
	_tmp9_ = surface;
	w = cairo_image_surface_get_width (_tmp9_);
	_tmp10_ = surface;
	h = cairo_image_surface_get_height (_tmp10_);
	slice = (guint8) (G_MAXUINT8 * threshold);
	_tmp11_ = w;
	left = _tmp11_;
	right = 0;
	_tmp12_ = h;
	top = _tmp12_;
	bottom = 0;
	_tmp13_ = surface;
	_tmp14_ = cairo_image_surface_get_data (_tmp13_);
	data = _tmp14_;
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp15_ = FALSE;
			_tmp15_ = TRUE;
			while (TRUE) {
				gint _tmp17_;
				gint _tmp18_;
				if (!_tmp15_) {
					gint _tmp16_;
					_tmp16_ = y;
					y = _tmp16_ + 1;
				}
				_tmp15_ = FALSE;
				_tmp17_ = y;
				_tmp18_ = h;
				if (!(_tmp17_ < _tmp18_)) {
					break;
				}
				{
					gint x = 0;
					x = 0;
					{
						gboolean _tmp19_ = FALSE;
						_tmp19_ = TRUE;
						while (TRUE) {
							gint _tmp21_;
							gint _tmp22_;
							gint _tmp23_;
							gint _tmp24_;
							gint _tmp25_;
							guint8* _tmp26_;
							gint _tmp27_;
							guint8 _tmp28_;
							guint8 _tmp29_;
							guint8* _tmp30_;
							gint _tmp31_;
							guint8 _tmp32_;
							guint8* _tmp33_;
							gint _tmp34_;
							guint8 _tmp35_;
							guint8* _tmp36_;
							gint _tmp37_;
							guint8 _tmp38_;
							guint8 _tmp39_ = 0U;
							gboolean _tmp40_;
							guint8* _tmp41_;
							gint _tmp42_;
							guint8 _tmp43_;
							gboolean _tmp44_;
							if (!_tmp19_) {
								gint _tmp20_;
								_tmp20_ = x;
								x = _tmp20_ + 1;
							}
							_tmp19_ = FALSE;
							_tmp21_ = x;
							_tmp22_ = w;
							if (!(_tmp21_ < _tmp22_)) {
								break;
							}
							_tmp23_ = y;
							_tmp24_ = w;
							_tmp25_ = x;
							src = ((_tmp23_ * _tmp24_) + _tmp25_) * 4;
							_tmp26_ = data;
							_tmp27_ = src;
							_tmp28_ = _tmp26_[_tmp27_ + 3];
							_tmp29_ = slice;
							mask = _tmp28_ > _tmp29_;
							_tmp30_ = data;
							_tmp31_ = src;
							_tmp30_[_tmp31_ + 0] = (guint8) 0;
							_tmp32_ = _tmp30_[_tmp31_ + 0];
							_tmp33_ = data;
							_tmp34_ = src;
							_tmp33_[_tmp34_ + 1] = (guint8) 0;
							_tmp35_ = _tmp33_[_tmp34_ + 1];
							_tmp36_ = data;
							_tmp37_ = src;
							_tmp36_[_tmp37_ + 2] = (guint8) 0;
							_tmp38_ = _tmp36_[_tmp37_ + 2];
							_tmp40_ = mask;
							if (_tmp40_) {
								_tmp39_ = G_MAXUINT8;
							} else {
								_tmp39_ = (guint8) 0;
							}
							_tmp41_ = data;
							_tmp42_ = src;
							_tmp41_[_tmp42_ + 3] = _tmp39_;
							_tmp43_ = _tmp41_[_tmp42_ + 3];
							_tmp44_ = mask;
							if (_tmp44_) {
								gint _tmp45_;
								gint _tmp46_;
								gint _tmp48_;
								gint _tmp49_;
								gint _tmp51_;
								gint _tmp52_;
								gint _tmp54_;
								gint _tmp55_;
								_tmp45_ = y;
								_tmp46_ = top;
								if (_tmp45_ < _tmp46_) {
									gint _tmp47_;
									_tmp47_ = y;
									top = _tmp47_;
								}
								_tmp48_ = y;
								_tmp49_ = bottom;
								if (_tmp48_ > _tmp49_) {
									gint _tmp50_;
									_tmp50_ = y;
									bottom = _tmp50_;
								}
								_tmp51_ = x;
								_tmp52_ = left;
								if (_tmp51_ < _tmp52_) {
									gint _tmp53_;
									_tmp53_ = x;
									left = _tmp53_;
								}
								_tmp54_ = x;
								_tmp55_ = right;
								if (_tmp54_ > _tmp55_) {
									gint _tmp56_;
									_tmp56_ = x;
									right = _tmp56_;
								}
							}
						}
					}
				}
			}
		}
	}
	_tmp57_ = left;
	_tmp58_ = top;
	_tmp59_ = right;
	_tmp60_ = left;
	_tmp61_ = bottom;
	_tmp62_ = top;
	_tmp63_.x = _tmp57_;
	_tmp63_.y = _tmp58_;
	_tmp63_.width = _tmp59_ - _tmp60_;
	_tmp63_.height = _tmp61_ - _tmp62_;
	_vala_extent = _tmp63_;
	_tmp64_ = surface;
	_tmp65_ = plank_surface_new_with_internal (_tmp64_);
	result = _tmp65_;
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (surface);
	if (extent) {
		*extent = _vala_extent;
	}
	return result;
}


/**
 * Computes and returns the average color of the surface.
 *
 * @return the average color of the surface
 */
void
plank_surface_average_color (PlankSurface* self,
                             PlankColor* result)
{
	cairo_surface_t* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	PlankColor _tmp5_ = {0};
	PlankColor _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_Internal;
	_tmp1_ = self->priv->_Width;
	_tmp2_ = self->priv->_Height;
	_tmp3_ = gdk_pixbuf_get_from_surface (_tmp0_, 0, 0, _tmp1_, _tmp2_);
	_tmp4_ = _tmp3_;
	plank_drawing_service_average_color (_tmp4_, &_tmp5_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp4_);
	*result = _tmp6_;
	return;
}


/**
 * Performs a fast blur on the surface.
 *
 * @param radius the radius of the blur
 * @param process_count how many iterations to blur
 */
void
plank_surface_fast_blur (PlankSurface* self,
                         gint radius,
                         gint process_count)
{
	gboolean _tmp0_ = FALSE;
	gint w = 0;
	gint _tmp1_;
	gint h = 0;
	gint _tmp2_;
	gint channels = 0;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_;
	cairo_surface_t* original = NULL;
	gint _tmp6_;
	gint _tmp7_;
	cairo_surface_t* _tmp8_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp9_;
	cairo_t* _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
	cairo_surface_t* _tmp13_;
	cairo_t* _tmp14_;
	guint8* pixels = NULL;
	cairo_surface_t* _tmp15_;
	guchar* _tmp16_;
	guint8* buffer = NULL;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	guint8* _tmp20_;
	gint buffer_length1;
	gint _buffer_size_;
	gint* vmin = NULL;
	gint _tmp21_;
	gint _tmp22_;
	gint* _tmp23_;
	gint vmin_length1;
	gint _vmin_size_;
	gint* vmax = NULL;
	gint _tmp24_;
	gint _tmp25_;
	gint* _tmp26_;
	gint vmax_length1;
	gint _vmax_size_;
	gint div = 0;
	guint8* dv = NULL;
	gint _tmp27_;
	guint8* _tmp28_;
	gint dv_length1;
	gint _dv_size_;
	cairo_surface_t* _tmp299_;
	cairo_t* target_cr = NULL;
	cairo_t* _tmp300_;
	cairo_t* _tmp301_;
	cairo_t* _tmp302_;
	cairo_t* _tmp303_;
	cairo_surface_t* _tmp304_;
	cairo_t* _tmp305_;
	cairo_t* _tmp306_;
	g_return_if_fail (self != NULL);
	if (radius < 1) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = process_count < 1;
	}
	if (_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->_Width;
	w = _tmp1_;
	_tmp2_ = self->priv->_Height;
	h = _tmp2_;
	channels = 4;
	_tmp4_ = w;
	if (radius > (_tmp4_ - 1)) {
		_tmp3_ = TRUE;
	} else {
		gint _tmp5_;
		_tmp5_ = h;
		_tmp3_ = radius > (_tmp5_ - 1);
	}
	if (_tmp3_) {
		return;
	}
	_tmp6_ = w;
	_tmp7_ = h;
	_tmp8_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp6_, _tmp7_);
	original = _tmp8_;
	_tmp9_ = original;
	_tmp10_ = cairo_create (_tmp9_);
	cr = _tmp10_;
	_tmp11_ = cr;
	cairo_set_operator (_tmp11_, CAIRO_OPERATOR_SOURCE);
	_tmp12_ = cr;
	_tmp13_ = self->priv->_Internal;
	cairo_set_source_surface (_tmp12_, _tmp13_, (gdouble) 0, (gdouble) 0);
	_tmp14_ = cr;
	cairo_paint (_tmp14_);
	_tmp15_ = original;
	_tmp16_ = cairo_image_surface_get_data (_tmp15_);
	pixels = _tmp16_;
	_tmp17_ = w;
	_tmp18_ = h;
	_tmp19_ = channels;
	_tmp20_ = g_new0 (guint8, (_tmp17_ * _tmp18_) * _tmp19_);
	buffer = _tmp20_;
	buffer_length1 = (_tmp17_ * _tmp18_) * _tmp19_;
	_buffer_size_ = buffer_length1;
	_tmp21_ = w;
	_tmp22_ = h;
	_tmp23_ = g_new0 (gint, MAX (_tmp21_, _tmp22_));
	vmin = _tmp23_;
	vmin_length1 = MAX (_tmp21_, _tmp22_);
	_vmin_size_ = vmin_length1;
	_tmp24_ = w;
	_tmp25_ = h;
	_tmp26_ = g_new0 (gint, MAX (_tmp24_, _tmp25_));
	vmax = _tmp26_;
	vmax_length1 = MAX (_tmp24_, _tmp25_);
	_vmax_size_ = vmax_length1;
	div = (2 * radius) + 1;
	_tmp27_ = div;
	_tmp28_ = g_new0 (guint8, 256 * _tmp27_);
	dv = _tmp28_;
	dv_length1 = 256 * _tmp27_;
	_dv_size_ = dv_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp29_ = FALSE;
			_tmp29_ = TRUE;
			while (TRUE) {
				gint _tmp31_;
				guint8* _tmp32_;
				gint _tmp32__length1;
				guint8* _tmp33_;
				gint _tmp33__length1;
				gint _tmp34_;
				gint _tmp35_;
				gint _tmp36_;
				guint8 _tmp37_;
				if (!_tmp29_) {
					gint _tmp30_;
					_tmp30_ = i;
					i = _tmp30_ + 1;
				}
				_tmp29_ = FALSE;
				_tmp31_ = i;
				_tmp32_ = dv;
				_tmp32__length1 = dv_length1;
				if (!(_tmp31_ < _tmp32__length1)) {
					break;
				}
				_tmp33_ = dv;
				_tmp33__length1 = dv_length1;
				_tmp34_ = i;
				_tmp35_ = i;
				_tmp36_ = div;
				_tmp33_[_tmp34_] = (guint8) (_tmp35_ / _tmp36_);
				_tmp37_ = _tmp33_[_tmp34_];
			}
		}
	}
	while (TRUE) {
		gint _tmp38_;
		_tmp38_ = process_count;
		process_count = _tmp38_ - 1;
		if (!(_tmp38_ > 0)) {
			break;
		}
		{
			gint x = 0;
			x = 0;
			{
				gboolean _tmp39_ = FALSE;
				_tmp39_ = TRUE;
				while (TRUE) {
					gint _tmp41_;
					gint _tmp42_;
					gint* _tmp43_;
					gint _tmp43__length1;
					gint _tmp44_;
					gint _tmp45_;
					gint _tmp46_;
					gint _tmp47_;
					gint* _tmp48_;
					gint _tmp48__length1;
					gint _tmp49_;
					gint _tmp50_;
					gint _tmp51_;
					if (!_tmp39_) {
						gint _tmp40_;
						_tmp40_ = x;
						x = _tmp40_ + 1;
					}
					_tmp39_ = FALSE;
					_tmp41_ = x;
					_tmp42_ = w;
					if (!(_tmp41_ < _tmp42_)) {
						break;
					}
					_tmp43_ = vmin;
					_tmp43__length1 = vmin_length1;
					_tmp44_ = x;
					_tmp45_ = x;
					_tmp46_ = w;
					_tmp43_[_tmp44_] = MIN ((_tmp45_ + radius) + 1, _tmp46_ - 1);
					_tmp47_ = _tmp43_[_tmp44_];
					_tmp48_ = vmax;
					_tmp48__length1 = vmax_length1;
					_tmp49_ = x;
					_tmp50_ = x;
					_tmp48_[_tmp49_] = MAX (_tmp50_ - radius, 0);
					_tmp51_ = _tmp48_[_tmp49_];
				}
			}
		}
		{
			gint y = 0;
			y = 0;
			{
				gboolean _tmp52_ = FALSE;
				_tmp52_ = TRUE;
				while (TRUE) {
					gint _tmp54_;
					gint _tmp55_;
					gint asum = 0;
					gint rsum = 0;
					gint gsum = 0;
					gint bsum = 0;
					guint32 cur_pixel = 0U;
					gint _tmp56_;
					gint _tmp57_;
					gint _tmp58_;
					gint _tmp59_;
					guint8* _tmp60_;
					guint32 _tmp61_;
					guint8 _tmp62_;
					gint _tmp63_;
					guint8* _tmp64_;
					guint32 _tmp65_;
					guint8 _tmp66_;
					gint _tmp67_;
					guint8* _tmp68_;
					guint32 _tmp69_;
					guint8 _tmp70_;
					gint _tmp71_;
					guint8* _tmp72_;
					guint32 _tmp73_;
					guint8 _tmp74_;
					gint _tmp96_;
					gint _tmp97_;
					gint _tmp98_;
					if (!_tmp52_) {
						gint _tmp53_;
						_tmp53_ = y;
						y = _tmp53_ + 1;
					}
					_tmp52_ = FALSE;
					_tmp54_ = y;
					_tmp55_ = h;
					if (!(_tmp54_ < _tmp55_)) {
						break;
					}
					asum = 0;
					rsum = 0;
					gsum = 0;
					bsum = 0;
					_tmp56_ = y;
					_tmp57_ = w;
					_tmp58_ = channels;
					cur_pixel = (guint32) ((_tmp56_ * _tmp57_) * _tmp58_);
					_tmp59_ = asum;
					_tmp60_ = pixels;
					_tmp61_ = cur_pixel;
					_tmp62_ = _tmp60_[_tmp61_ + 0];
					asum = _tmp59_ + (radius * _tmp62_);
					_tmp63_ = rsum;
					_tmp64_ = pixels;
					_tmp65_ = cur_pixel;
					_tmp66_ = _tmp64_[_tmp65_ + 1];
					rsum = _tmp63_ + (radius * _tmp66_);
					_tmp67_ = gsum;
					_tmp68_ = pixels;
					_tmp69_ = cur_pixel;
					_tmp70_ = _tmp68_[_tmp69_ + 2];
					gsum = _tmp67_ + (radius * _tmp70_);
					_tmp71_ = bsum;
					_tmp72_ = pixels;
					_tmp73_ = cur_pixel;
					_tmp74_ = _tmp72_[_tmp73_ + 3];
					bsum = _tmp71_ + (radius * _tmp74_);
					{
						gint i = 0;
						i = 0;
						{
							gboolean _tmp75_ = FALSE;
							_tmp75_ = TRUE;
							while (TRUE) {
								gint _tmp77_;
								gint _tmp78_;
								guint8* _tmp79_;
								guint32 _tmp80_;
								guint8 _tmp81_;
								gint _tmp82_;
								guint8* _tmp83_;
								guint32 _tmp84_;
								guint8 _tmp85_;
								gint _tmp86_;
								guint8* _tmp87_;
								guint32 _tmp88_;
								guint8 _tmp89_;
								gint _tmp90_;
								guint8* _tmp91_;
								guint32 _tmp92_;
								guint8 _tmp93_;
								guint32 _tmp94_;
								gint _tmp95_;
								if (!_tmp75_) {
									gint _tmp76_;
									_tmp76_ = i;
									i = _tmp76_ + 1;
								}
								_tmp75_ = FALSE;
								_tmp77_ = i;
								if (!(_tmp77_ <= radius)) {
									break;
								}
								_tmp78_ = asum;
								_tmp79_ = pixels;
								_tmp80_ = cur_pixel;
								_tmp81_ = _tmp79_[_tmp80_ + 0];
								asum = _tmp78_ + _tmp81_;
								_tmp82_ = rsum;
								_tmp83_ = pixels;
								_tmp84_ = cur_pixel;
								_tmp85_ = _tmp83_[_tmp84_ + 1];
								rsum = _tmp82_ + _tmp85_;
								_tmp86_ = gsum;
								_tmp87_ = pixels;
								_tmp88_ = cur_pixel;
								_tmp89_ = _tmp87_[_tmp88_ + 2];
								gsum = _tmp86_ + _tmp89_;
								_tmp90_ = bsum;
								_tmp91_ = pixels;
								_tmp92_ = cur_pixel;
								_tmp93_ = _tmp91_[_tmp92_ + 3];
								bsum = _tmp90_ + _tmp93_;
								_tmp94_ = cur_pixel;
								_tmp95_ = channels;
								cur_pixel = _tmp94_ + _tmp95_;
							}
						}
					}
					_tmp96_ = y;
					_tmp97_ = w;
					_tmp98_ = channels;
					cur_pixel = (guint32) ((_tmp96_ * _tmp97_) * _tmp98_);
					{
						gint x = 0;
						x = 0;
						{
							gboolean _tmp99_ = FALSE;
							_tmp99_ = TRUE;
							while (TRUE) {
								gint _tmp101_;
								gint _tmp102_;
								guint32 p1 = 0U;
								gint _tmp103_;
								gint _tmp104_;
								gint* _tmp105_;
								gint _tmp105__length1;
								gint _tmp106_;
								gint _tmp107_;
								gint _tmp108_;
								guint32 p2 = 0U;
								gint _tmp109_;
								gint _tmp110_;
								gint* _tmp111_;
								gint _tmp111__length1;
								gint _tmp112_;
								gint _tmp113_;
								gint _tmp114_;
								guint8* _tmp115_;
								gint _tmp115__length1;
								guint32 _tmp116_;
								guint8* _tmp117_;
								gint _tmp117__length1;
								gint _tmp118_;
								guint8 _tmp119_;
								guint8 _tmp120_;
								guint8* _tmp121_;
								gint _tmp121__length1;
								guint32 _tmp122_;
								guint8* _tmp123_;
								gint _tmp123__length1;
								gint _tmp124_;
								guint8 _tmp125_;
								guint8 _tmp126_;
								guint8* _tmp127_;
								gint _tmp127__length1;
								guint32 _tmp128_;
								guint8* _tmp129_;
								gint _tmp129__length1;
								gint _tmp130_;
								guint8 _tmp131_;
								guint8 _tmp132_;
								guint8* _tmp133_;
								gint _tmp133__length1;
								guint32 _tmp134_;
								guint8* _tmp135_;
								gint _tmp135__length1;
								gint _tmp136_;
								guint8 _tmp137_;
								guint8 _tmp138_;
								gint _tmp139_;
								guint8* _tmp140_;
								guint32 _tmp141_;
								guint8 _tmp142_;
								guint8* _tmp143_;
								guint32 _tmp144_;
								guint8 _tmp145_;
								gint _tmp146_;
								guint8* _tmp147_;
								guint32 _tmp148_;
								guint8 _tmp149_;
								guint8* _tmp150_;
								guint32 _tmp151_;
								guint8 _tmp152_;
								gint _tmp153_;
								guint8* _tmp154_;
								guint32 _tmp155_;
								guint8 _tmp156_;
								guint8* _tmp157_;
								guint32 _tmp158_;
								guint8 _tmp159_;
								gint _tmp160_;
								guint8* _tmp161_;
								guint32 _tmp162_;
								guint8 _tmp163_;
								guint8* _tmp164_;
								guint32 _tmp165_;
								guint8 _tmp166_;
								guint32 _tmp167_;
								gint _tmp168_;
								if (!_tmp99_) {
									gint _tmp100_;
									_tmp100_ = x;
									x = _tmp100_ + 1;
								}
								_tmp99_ = FALSE;
								_tmp101_ = x;
								_tmp102_ = w;
								if (!(_tmp101_ < _tmp102_)) {
									break;
								}
								_tmp103_ = y;
								_tmp104_ = w;
								_tmp105_ = vmin;
								_tmp105__length1 = vmin_length1;
								_tmp106_ = x;
								_tmp107_ = _tmp105_[_tmp106_];
								_tmp108_ = channels;
								p1 = (guint32) (((_tmp103_ * _tmp104_) + _tmp107_) * _tmp108_);
								_tmp109_ = y;
								_tmp110_ = w;
								_tmp111_ = vmax;
								_tmp111__length1 = vmax_length1;
								_tmp112_ = x;
								_tmp113_ = _tmp111_[_tmp112_];
								_tmp114_ = channels;
								p2 = (guint32) (((_tmp109_ * _tmp110_) + _tmp113_) * _tmp114_);
								_tmp115_ = buffer;
								_tmp115__length1 = buffer_length1;
								_tmp116_ = cur_pixel;
								_tmp117_ = dv;
								_tmp117__length1 = dv_length1;
								_tmp118_ = asum;
								_tmp119_ = _tmp117_[_tmp118_];
								_tmp115_[_tmp116_ + 0] = _tmp119_;
								_tmp120_ = _tmp115_[_tmp116_ + 0];
								_tmp121_ = buffer;
								_tmp121__length1 = buffer_length1;
								_tmp122_ = cur_pixel;
								_tmp123_ = dv;
								_tmp123__length1 = dv_length1;
								_tmp124_ = rsum;
								_tmp125_ = _tmp123_[_tmp124_];
								_tmp121_[_tmp122_ + 1] = _tmp125_;
								_tmp126_ = _tmp121_[_tmp122_ + 1];
								_tmp127_ = buffer;
								_tmp127__length1 = buffer_length1;
								_tmp128_ = cur_pixel;
								_tmp129_ = dv;
								_tmp129__length1 = dv_length1;
								_tmp130_ = gsum;
								_tmp131_ = _tmp129_[_tmp130_];
								_tmp127_[_tmp128_ + 2] = _tmp131_;
								_tmp132_ = _tmp127_[_tmp128_ + 2];
								_tmp133_ = buffer;
								_tmp133__length1 = buffer_length1;
								_tmp134_ = cur_pixel;
								_tmp135_ = dv;
								_tmp135__length1 = dv_length1;
								_tmp136_ = bsum;
								_tmp137_ = _tmp135_[_tmp136_];
								_tmp133_[_tmp134_ + 3] = _tmp137_;
								_tmp138_ = _tmp133_[_tmp134_ + 3];
								_tmp139_ = asum;
								_tmp140_ = pixels;
								_tmp141_ = p1;
								_tmp142_ = _tmp140_[_tmp141_ + 0];
								_tmp143_ = pixels;
								_tmp144_ = p2;
								_tmp145_ = _tmp143_[_tmp144_ + 0];
								asum = _tmp139_ + (_tmp142_ - _tmp145_);
								_tmp146_ = rsum;
								_tmp147_ = pixels;
								_tmp148_ = p1;
								_tmp149_ = _tmp147_[_tmp148_ + 1];
								_tmp150_ = pixels;
								_tmp151_ = p2;
								_tmp152_ = _tmp150_[_tmp151_ + 1];
								rsum = _tmp146_ + (_tmp149_ - _tmp152_);
								_tmp153_ = gsum;
								_tmp154_ = pixels;
								_tmp155_ = p1;
								_tmp156_ = _tmp154_[_tmp155_ + 2];
								_tmp157_ = pixels;
								_tmp158_ = p2;
								_tmp159_ = _tmp157_[_tmp158_ + 2];
								gsum = _tmp153_ + (_tmp156_ - _tmp159_);
								_tmp160_ = bsum;
								_tmp161_ = pixels;
								_tmp162_ = p1;
								_tmp163_ = _tmp161_[_tmp162_ + 3];
								_tmp164_ = pixels;
								_tmp165_ = p2;
								_tmp166_ = _tmp164_[_tmp165_ + 3];
								bsum = _tmp160_ + (_tmp163_ - _tmp166_);
								_tmp167_ = cur_pixel;
								_tmp168_ = channels;
								cur_pixel = _tmp167_ + _tmp168_;
							}
						}
					}
				}
			}
		}
		{
			gint y = 0;
			y = 0;
			{
				gboolean _tmp169_ = FALSE;
				_tmp169_ = TRUE;
				while (TRUE) {
					gint _tmp171_;
					gint _tmp172_;
					gint* _tmp173_;
					gint _tmp173__length1;
					gint _tmp174_;
					gint _tmp175_;
					gint _tmp176_;
					gint _tmp177_;
					gint _tmp178_;
					gint* _tmp179_;
					gint _tmp179__length1;
					gint _tmp180_;
					gint _tmp181_;
					gint _tmp182_;
					gint _tmp183_;
					if (!_tmp169_) {
						gint _tmp170_;
						_tmp170_ = y;
						y = _tmp170_ + 1;
					}
					_tmp169_ = FALSE;
					_tmp171_ = y;
					_tmp172_ = h;
					if (!(_tmp171_ < _tmp172_)) {
						break;
					}
					_tmp173_ = vmin;
					_tmp173__length1 = vmin_length1;
					_tmp174_ = y;
					_tmp175_ = y;
					_tmp176_ = h;
					_tmp177_ = w;
					_tmp173_[_tmp174_] = MIN ((_tmp175_ + radius) + 1, _tmp176_ - 1) * _tmp177_;
					_tmp178_ = _tmp173_[_tmp174_];
					_tmp179_ = vmax;
					_tmp179__length1 = vmax_length1;
					_tmp180_ = y;
					_tmp181_ = y;
					_tmp182_ = w;
					_tmp179_[_tmp180_] = MAX (_tmp181_ - radius, 0) * _tmp182_;
					_tmp183_ = _tmp179_[_tmp180_];
				}
			}
		}
		{
			gint x = 0;
			x = 0;
			{
				gboolean _tmp184_ = FALSE;
				_tmp184_ = TRUE;
				while (TRUE) {
					gint _tmp186_;
					gint _tmp187_;
					gint asum = 0;
					gint rsum = 0;
					gint gsum = 0;
					gint bsum = 0;
					guint32 cur_pixel = 0U;
					gint _tmp188_;
					gint _tmp189_;
					gint _tmp190_;
					guint8* _tmp191_;
					gint _tmp191__length1;
					guint32 _tmp192_;
					guint8 _tmp193_;
					gint _tmp194_;
					guint8* _tmp195_;
					gint _tmp195__length1;
					guint32 _tmp196_;
					guint8 _tmp197_;
					gint _tmp198_;
					guint8* _tmp199_;
					gint _tmp199__length1;
					guint32 _tmp200_;
					guint8 _tmp201_;
					gint _tmp202_;
					guint8* _tmp203_;
					gint _tmp203__length1;
					guint32 _tmp204_;
					guint8 _tmp205_;
					gint _tmp228_;
					gint _tmp229_;
					if (!_tmp184_) {
						gint _tmp185_;
						_tmp185_ = x;
						x = _tmp185_ + 1;
					}
					_tmp184_ = FALSE;
					_tmp186_ = x;
					_tmp187_ = w;
					if (!(_tmp186_ < _tmp187_)) {
						break;
					}
					asum = 0;
					rsum = 0;
					gsum = 0;
					bsum = 0;
					_tmp188_ = x;
					_tmp189_ = channels;
					cur_pixel = (guint32) (_tmp188_ * _tmp189_);
					_tmp190_ = asum;
					_tmp191_ = buffer;
					_tmp191__length1 = buffer_length1;
					_tmp192_ = cur_pixel;
					_tmp193_ = _tmp191_[_tmp192_ + 0];
					asum = _tmp190_ + (radius * _tmp193_);
					_tmp194_ = rsum;
					_tmp195_ = buffer;
					_tmp195__length1 = buffer_length1;
					_tmp196_ = cur_pixel;
					_tmp197_ = _tmp195_[_tmp196_ + 1];
					rsum = _tmp194_ + (radius * _tmp197_);
					_tmp198_ = gsum;
					_tmp199_ = buffer;
					_tmp199__length1 = buffer_length1;
					_tmp200_ = cur_pixel;
					_tmp201_ = _tmp199_[_tmp200_ + 2];
					gsum = _tmp198_ + (radius * _tmp201_);
					_tmp202_ = bsum;
					_tmp203_ = buffer;
					_tmp203__length1 = buffer_length1;
					_tmp204_ = cur_pixel;
					_tmp205_ = _tmp203_[_tmp204_ + 3];
					bsum = _tmp202_ + (radius * _tmp205_);
					{
						gint i = 0;
						i = 0;
						{
							gboolean _tmp206_ = FALSE;
							_tmp206_ = TRUE;
							while (TRUE) {
								gint _tmp208_;
								gint _tmp209_;
								guint8* _tmp210_;
								gint _tmp210__length1;
								guint32 _tmp211_;
								guint8 _tmp212_;
								gint _tmp213_;
								guint8* _tmp214_;
								gint _tmp214__length1;
								guint32 _tmp215_;
								guint8 _tmp216_;
								gint _tmp217_;
								guint8* _tmp218_;
								gint _tmp218__length1;
								guint32 _tmp219_;
								guint8 _tmp220_;
								gint _tmp221_;
								guint8* _tmp222_;
								gint _tmp222__length1;
								guint32 _tmp223_;
								guint8 _tmp224_;
								guint32 _tmp225_;
								gint _tmp226_;
								gint _tmp227_;
								if (!_tmp206_) {
									gint _tmp207_;
									_tmp207_ = i;
									i = _tmp207_ + 1;
								}
								_tmp206_ = FALSE;
								_tmp208_ = i;
								if (!(_tmp208_ <= radius)) {
									break;
								}
								_tmp209_ = asum;
								_tmp210_ = buffer;
								_tmp210__length1 = buffer_length1;
								_tmp211_ = cur_pixel;
								_tmp212_ = _tmp210_[_tmp211_ + 0];
								asum = _tmp209_ + _tmp212_;
								_tmp213_ = rsum;
								_tmp214_ = buffer;
								_tmp214__length1 = buffer_length1;
								_tmp215_ = cur_pixel;
								_tmp216_ = _tmp214_[_tmp215_ + 1];
								rsum = _tmp213_ + _tmp216_;
								_tmp217_ = gsum;
								_tmp218_ = buffer;
								_tmp218__length1 = buffer_length1;
								_tmp219_ = cur_pixel;
								_tmp220_ = _tmp218_[_tmp219_ + 2];
								gsum = _tmp217_ + _tmp220_;
								_tmp221_ = bsum;
								_tmp222_ = buffer;
								_tmp222__length1 = buffer_length1;
								_tmp223_ = cur_pixel;
								_tmp224_ = _tmp222_[_tmp223_ + 3];
								bsum = _tmp221_ + _tmp224_;
								_tmp225_ = cur_pixel;
								_tmp226_ = w;
								_tmp227_ = channels;
								cur_pixel = _tmp225_ + (_tmp226_ * _tmp227_);
							}
						}
					}
					_tmp228_ = x;
					_tmp229_ = channels;
					cur_pixel = (guint32) (_tmp228_ * _tmp229_);
					{
						gint y = 0;
						y = 0;
						{
							gboolean _tmp230_ = FALSE;
							_tmp230_ = TRUE;
							while (TRUE) {
								gint _tmp232_;
								gint _tmp233_;
								guint32 p1 = 0U;
								gint _tmp234_;
								gint* _tmp235_;
								gint _tmp235__length1;
								gint _tmp236_;
								gint _tmp237_;
								gint _tmp238_;
								guint32 p2 = 0U;
								gint _tmp239_;
								gint* _tmp240_;
								gint _tmp240__length1;
								gint _tmp241_;
								gint _tmp242_;
								gint _tmp243_;
								guint8* _tmp244_;
								guint32 _tmp245_;
								guint8* _tmp246_;
								gint _tmp246__length1;
								gint _tmp247_;
								guint8 _tmp248_;
								guint8 _tmp249_;
								guint8* _tmp250_;
								guint32 _tmp251_;
								guint8* _tmp252_;
								gint _tmp252__length1;
								gint _tmp253_;
								guint8 _tmp254_;
								guint8 _tmp255_;
								guint8* _tmp256_;
								guint32 _tmp257_;
								guint8* _tmp258_;
								gint _tmp258__length1;
								gint _tmp259_;
								guint8 _tmp260_;
								guint8 _tmp261_;
								guint8* _tmp262_;
								guint32 _tmp263_;
								guint8* _tmp264_;
								gint _tmp264__length1;
								gint _tmp265_;
								guint8 _tmp266_;
								guint8 _tmp267_;
								gint _tmp268_;
								guint8* _tmp269_;
								gint _tmp269__length1;
								guint32 _tmp270_;
								guint8 _tmp271_;
								guint8* _tmp272_;
								gint _tmp272__length1;
								guint32 _tmp273_;
								guint8 _tmp274_;
								gint _tmp275_;
								guint8* _tmp276_;
								gint _tmp276__length1;
								guint32 _tmp277_;
								guint8 _tmp278_;
								guint8* _tmp279_;
								gint _tmp279__length1;
								guint32 _tmp280_;
								guint8 _tmp281_;
								gint _tmp282_;
								guint8* _tmp283_;
								gint _tmp283__length1;
								guint32 _tmp284_;
								guint8 _tmp285_;
								guint8* _tmp286_;
								gint _tmp286__length1;
								guint32 _tmp287_;
								guint8 _tmp288_;
								gint _tmp289_;
								guint8* _tmp290_;
								gint _tmp290__length1;
								guint32 _tmp291_;
								guint8 _tmp292_;
								guint8* _tmp293_;
								gint _tmp293__length1;
								guint32 _tmp294_;
								guint8 _tmp295_;
								guint32 _tmp296_;
								gint _tmp297_;
								gint _tmp298_;
								if (!_tmp230_) {
									gint _tmp231_;
									_tmp231_ = y;
									y = _tmp231_ + 1;
								}
								_tmp230_ = FALSE;
								_tmp232_ = y;
								_tmp233_ = h;
								if (!(_tmp232_ < _tmp233_)) {
									break;
								}
								_tmp234_ = x;
								_tmp235_ = vmin;
								_tmp235__length1 = vmin_length1;
								_tmp236_ = y;
								_tmp237_ = _tmp235_[_tmp236_];
								_tmp238_ = channels;
								p1 = (guint32) ((_tmp234_ + _tmp237_) * _tmp238_);
								_tmp239_ = x;
								_tmp240_ = vmax;
								_tmp240__length1 = vmax_length1;
								_tmp241_ = y;
								_tmp242_ = _tmp240_[_tmp241_];
								_tmp243_ = channels;
								p2 = (guint32) ((_tmp239_ + _tmp242_) * _tmp243_);
								_tmp244_ = pixels;
								_tmp245_ = cur_pixel;
								_tmp246_ = dv;
								_tmp246__length1 = dv_length1;
								_tmp247_ = asum;
								_tmp248_ = _tmp246_[_tmp247_];
								_tmp244_[_tmp245_ + 0] = _tmp248_;
								_tmp249_ = _tmp244_[_tmp245_ + 0];
								_tmp250_ = pixels;
								_tmp251_ = cur_pixel;
								_tmp252_ = dv;
								_tmp252__length1 = dv_length1;
								_tmp253_ = rsum;
								_tmp254_ = _tmp252_[_tmp253_];
								_tmp250_[_tmp251_ + 1] = _tmp254_;
								_tmp255_ = _tmp250_[_tmp251_ + 1];
								_tmp256_ = pixels;
								_tmp257_ = cur_pixel;
								_tmp258_ = dv;
								_tmp258__length1 = dv_length1;
								_tmp259_ = gsum;
								_tmp260_ = _tmp258_[_tmp259_];
								_tmp256_[_tmp257_ + 2] = _tmp260_;
								_tmp261_ = _tmp256_[_tmp257_ + 2];
								_tmp262_ = pixels;
								_tmp263_ = cur_pixel;
								_tmp264_ = dv;
								_tmp264__length1 = dv_length1;
								_tmp265_ = bsum;
								_tmp266_ = _tmp264_[_tmp265_];
								_tmp262_[_tmp263_ + 3] = _tmp266_;
								_tmp267_ = _tmp262_[_tmp263_ + 3];
								_tmp268_ = asum;
								_tmp269_ = buffer;
								_tmp269__length1 = buffer_length1;
								_tmp270_ = p1;
								_tmp271_ = _tmp269_[_tmp270_ + 0];
								_tmp272_ = buffer;
								_tmp272__length1 = buffer_length1;
								_tmp273_ = p2;
								_tmp274_ = _tmp272_[_tmp273_ + 0];
								asum = _tmp268_ + (_tmp271_ - _tmp274_);
								_tmp275_ = rsum;
								_tmp276_ = buffer;
								_tmp276__length1 = buffer_length1;
								_tmp277_ = p1;
								_tmp278_ = _tmp276_[_tmp277_ + 1];
								_tmp279_ = buffer;
								_tmp279__length1 = buffer_length1;
								_tmp280_ = p2;
								_tmp281_ = _tmp279_[_tmp280_ + 1];
								rsum = _tmp275_ + (_tmp278_ - _tmp281_);
								_tmp282_ = gsum;
								_tmp283_ = buffer;
								_tmp283__length1 = buffer_length1;
								_tmp284_ = p1;
								_tmp285_ = _tmp283_[_tmp284_ + 2];
								_tmp286_ = buffer;
								_tmp286__length1 = buffer_length1;
								_tmp287_ = p2;
								_tmp288_ = _tmp286_[_tmp287_ + 2];
								gsum = _tmp282_ + (_tmp285_ - _tmp288_);
								_tmp289_ = bsum;
								_tmp290_ = buffer;
								_tmp290__length1 = buffer_length1;
								_tmp291_ = p1;
								_tmp292_ = _tmp290_[_tmp291_ + 3];
								_tmp293_ = buffer;
								_tmp293__length1 = buffer_length1;
								_tmp294_ = p2;
								_tmp295_ = _tmp293_[_tmp294_ + 3];
								bsum = _tmp289_ + (_tmp292_ - _tmp295_);
								_tmp296_ = cur_pixel;
								_tmp297_ = w;
								_tmp298_ = channels;
								cur_pixel = _tmp296_ + (_tmp297_ * _tmp298_);
							}
						}
					}
				}
			}
		}
	}
	_tmp299_ = original;
	cairo_surface_mark_dirty (_tmp299_);
	_tmp300_ = self->priv->_Context;
	target_cr = _tmp300_;
	_tmp301_ = target_cr;
	cairo_save (_tmp301_);
	_tmp302_ = target_cr;
	cairo_set_operator (_tmp302_, CAIRO_OPERATOR_SOURCE);
	_tmp303_ = target_cr;
	_tmp304_ = original;
	cairo_set_source_surface (_tmp303_, _tmp304_, (gdouble) 0, (gdouble) 0);
	_tmp305_ = target_cr;
	cairo_paint (_tmp305_);
	_tmp306_ = target_cr;
	cairo_restore (_tmp306_);
	dv = (g_free (dv), NULL);
	vmax = (g_free (vmax), NULL);
	vmin = (g_free (vmin), NULL);
	buffer = (g_free (buffer), NULL);
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (original);
}


/**
 * Performs an exponential blur on the surface.
 *
 * @param radius the radius of the blur
 */
static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}


static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		PlankSurface* self;
		self = _data5_->self;
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}


static void*
__lambda4_ (Block5Data* _data5_)
{
	PlankSurface* self;
	void* result = NULL;
	guint8* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	self = _data5_->self;
	_tmp0_ = _data5_->pixels;
	_tmp1_ = _data5_->width;
	_tmp2_ = _data5_->height;
	_tmp3_ = _data5_->height;
	_tmp4_ = _data5_->width;
	_tmp5_ = _data5_->alpha;
	plank_surface_exponential_blur_rows (_tmp0_, _tmp1_, _tmp2_, 0, _tmp3_ / 2, 0, _tmp4_, _tmp5_);
	result = NULL;
	return result;
}


static gpointer
___lambda4__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda4_ (self);
	block5_data_unref (self);
	return result;
}


static gpointer
_g_thread_ref0 (gpointer self)
{
	return self ? g_thread_ref (self) : NULL;
}


static void*
__lambda5_ (Block5Data* _data5_)
{
	PlankSurface* self;
	void* result = NULL;
	guint8* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	self = _data5_->self;
	_tmp0_ = _data5_->pixels;
	_tmp1_ = _data5_->width;
	_tmp2_ = _data5_->height;
	_tmp3_ = _data5_->width;
	_tmp4_ = _data5_->height;
	_tmp5_ = _data5_->alpha;
	plank_surface_exponential_blur_columns (_tmp0_, _tmp1_, _tmp2_, 0, _tmp3_ / 2, 0, _tmp4_, _tmp5_);
	result = NULL;
	return result;
}


static gpointer
___lambda5__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda5_ (self);
	block5_data_unref (self);
	return result;
}


void
plank_surface_exponential_blur (PlankSurface* self,
                                gint radius)
{
	Block5Data* _data5_;
	gint _tmp0_;
	gint _tmp1_;
	cairo_surface_t* original = NULL;
	gint _tmp2_;
	gint _tmp3_;
	cairo_surface_t* _tmp4_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_t* _tmp8_;
	cairo_surface_t* _tmp9_;
	cairo_t* _tmp10_;
	cairo_surface_t* _tmp11_;
	guchar* _tmp12_;
	GThread* th = NULL;
	GThread* _tmp13_;
	guint8* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	GThread* _tmp21_;
	GThread* _tmp22_;
	GThread* th2 = NULL;
	GThread* _tmp23_;
	guint8* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	GThread* _tmp31_;
	GThread* _tmp32_;
	cairo_surface_t* _tmp33_;
	cairo_t* target_cr = NULL;
	cairo_t* _tmp34_;
	cairo_t* _tmp35_;
	cairo_t* _tmp36_;
	cairo_t* _tmp37_;
	cairo_surface_t* _tmp38_;
	cairo_t* _tmp39_;
	cairo_t* _tmp40_;
	g_return_if_fail (self != NULL);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	if (radius < 1) {
		block5_data_unref (_data5_);
		_data5_ = NULL;
		return;
	}
	_data5_->alpha = (gint) ((1 << PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION) * (1.0 - exp ((-2.3) / (radius + 1.0))));
	_tmp0_ = self->priv->_Height;
	_data5_->height = _tmp0_;
	_tmp1_ = self->priv->_Width;
	_data5_->width = _tmp1_;
	_tmp2_ = _data5_->width;
	_tmp3_ = _data5_->height;
	_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp2_, _tmp3_);
	original = _tmp4_;
	_tmp5_ = original;
	_tmp6_ = cairo_create (_tmp5_);
	cr = _tmp6_;
	_tmp7_ = cr;
	cairo_set_operator (_tmp7_, CAIRO_OPERATOR_SOURCE);
	_tmp8_ = cr;
	_tmp9_ = self->priv->_Internal;
	cairo_set_source_surface (_tmp8_, _tmp9_, (gdouble) 0, (gdouble) 0);
	_tmp10_ = cr;
	cairo_paint (_tmp10_);
	_tmp11_ = original;
	_tmp12_ = cairo_image_surface_get_data (_tmp11_);
	_data5_->pixels = _tmp12_;
	_tmp13_ = g_thread_new (NULL, ___lambda4__gthread_func, block5_data_ref (_data5_));
	th = _tmp13_;
	_tmp14_ = _data5_->pixels;
	_tmp15_ = _data5_->width;
	_tmp16_ = _data5_->height;
	_tmp17_ = _data5_->height;
	_tmp18_ = _data5_->height;
	_tmp19_ = _data5_->width;
	_tmp20_ = _data5_->alpha;
	plank_surface_exponential_blur_rows (_tmp14_, _tmp15_, _tmp16_, _tmp17_ / 2, _tmp18_, 0, _tmp19_, _tmp20_);
	_tmp21_ = th;
	_tmp22_ = _g_thread_ref0 (_tmp21_);
	g_thread_join (_tmp22_);
	_tmp23_ = g_thread_new (NULL, ___lambda5__gthread_func, block5_data_ref (_data5_));
	th2 = _tmp23_;
	_tmp24_ = _data5_->pixels;
	_tmp25_ = _data5_->width;
	_tmp26_ = _data5_->height;
	_tmp27_ = _data5_->width;
	_tmp28_ = _data5_->width;
	_tmp29_ = _data5_->height;
	_tmp30_ = _data5_->alpha;
	plank_surface_exponential_blur_columns (_tmp24_, _tmp25_, _tmp26_, _tmp27_ / 2, _tmp28_, 0, _tmp29_, _tmp30_);
	_tmp31_ = th2;
	_tmp32_ = _g_thread_ref0 (_tmp31_);
	g_thread_join (_tmp32_);
	_tmp33_ = original;
	cairo_surface_mark_dirty (_tmp33_);
	_tmp34_ = self->priv->_Context;
	target_cr = _tmp34_;
	_tmp35_ = target_cr;
	cairo_save (_tmp35_);
	_tmp36_ = target_cr;
	cairo_set_operator (_tmp36_, CAIRO_OPERATOR_SOURCE);
	_tmp37_ = target_cr;
	_tmp38_ = original;
	cairo_set_source_surface (_tmp37_, _tmp38_, (gdouble) 0, (gdouble) 0);
	_tmp39_ = target_cr;
	cairo_paint (_tmp39_);
	_tmp40_ = target_cr;
	cairo_restore (_tmp40_);
	_g_thread_unref0 (th2);
	_g_thread_unref0 (th);
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (original);
	block5_data_unref (_data5_);
	_data5_ = NULL;
}


static void
plank_surface_exponential_blur_columns (guint8* pixels,
                                        gint width,
                                        gint height,
                                        gint startCol,
                                        gint endCol,
                                        gint startY,
                                        gint endY,
                                        gint alpha)
{
	{
		gint columnIndex = 0;
		columnIndex = startCol;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				guint8* column = NULL;
				gint _tmp3_;
				gint zA = 0;
				guint8* _tmp4_;
				guint8 _tmp5_;
				gint zR = 0;
				guint8* _tmp6_;
				guint8 _tmp7_;
				gint zG = 0;
				guint8* _tmp8_;
				guint8 _tmp9_;
				gint zB = 0;
				guint8* _tmp10_;
				guint8 _tmp11_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = columnIndex;
					columnIndex = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = columnIndex;
				if (!(_tmp2_ < endCol)) {
					break;
				}
				_tmp3_ = columnIndex;
				column = pixels + (_tmp3_ * 4);
				_tmp4_ = column;
				_tmp5_ = _tmp4_[0];
				zA = _tmp5_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp6_ = column;
				_tmp7_ = _tmp6_[1];
				zR = _tmp7_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp8_ = column;
				_tmp9_ = _tmp8_[2];
				zG = _tmp9_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp10_ = column;
				_tmp11_ = _tmp10_[3];
				zB = _tmp11_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				{
					gint index = 0;
					index = width * (startY + 1);
					{
						gboolean _tmp12_ = FALSE;
						_tmp12_ = TRUE;
						while (TRUE) {
							gint _tmp14_;
							guint8* _tmp15_;
							gint _tmp16_;
							if (!_tmp12_) {
								gint _tmp13_;
								_tmp13_ = index;
								index = _tmp13_ + width;
							}
							_tmp12_ = FALSE;
							_tmp14_ = index;
							if (!(_tmp14_ < ((endY - 1) * width))) {
								break;
							}
							_tmp15_ = column;
							_tmp16_ = index;
							plank_surface_exponential_blur_inner (&_tmp15_[_tmp16_ * 4], &zA, &zR, &zG, &zB, alpha);
						}
					}
				}
				{
					gint index = 0;
					index = (endY - 2) * width;
					{
						gboolean _tmp17_ = FALSE;
						_tmp17_ = TRUE;
						while (TRUE) {
							gint _tmp19_;
							guint8* _tmp20_;
							gint _tmp21_;
							if (!_tmp17_) {
								gint _tmp18_;
								_tmp18_ = index;
								index = _tmp18_ - width;
							}
							_tmp17_ = FALSE;
							_tmp19_ = index;
							if (!(_tmp19_ >= startY)) {
								break;
							}
							_tmp20_ = column;
							_tmp21_ = index;
							plank_surface_exponential_blur_inner (&_tmp20_[_tmp21_ * 4], &zA, &zR, &zG, &zB, alpha);
						}
					}
				}
			}
		}
	}
}


static void
plank_surface_exponential_blur_rows (guint8* pixels,
                                     gint width,
                                     gint height,
                                     gint startRow,
                                     gint endRow,
                                     gint startX,
                                     gint endX,
                                     gint alpha)
{
	{
		gint rowIndex = 0;
		rowIndex = startRow;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				guint8* row = NULL;
				gint _tmp3_;
				gint zA = 0;
				guint8* _tmp4_;
				guint8 _tmp5_;
				gint zR = 0;
				guint8* _tmp6_;
				guint8 _tmp7_;
				gint zG = 0;
				guint8* _tmp8_;
				guint8 _tmp9_;
				gint zB = 0;
				guint8* _tmp10_;
				guint8 _tmp11_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = rowIndex;
					rowIndex = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = rowIndex;
				if (!(_tmp2_ < endRow)) {
					break;
				}
				_tmp3_ = rowIndex;
				row = pixels + ((_tmp3_ * width) * 4);
				_tmp4_ = row;
				_tmp5_ = _tmp4_[startX + 0];
				zA = _tmp5_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp6_ = row;
				_tmp7_ = _tmp6_[startX + 1];
				zR = _tmp7_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp8_ = row;
				_tmp9_ = _tmp8_[startX + 2];
				zG = _tmp9_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp10_ = row;
				_tmp11_ = _tmp10_[startX + 3];
				zB = _tmp11_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				{
					gint index = 0;
					index = startX + 1;
					{
						gboolean _tmp12_ = FALSE;
						_tmp12_ = TRUE;
						while (TRUE) {
							gint _tmp14_;
							guint8* _tmp15_;
							gint _tmp16_;
							if (!_tmp12_) {
								gint _tmp13_;
								_tmp13_ = index;
								index = _tmp13_ + 1;
							}
							_tmp12_ = FALSE;
							_tmp14_ = index;
							if (!(_tmp14_ < endX)) {
								break;
							}
							_tmp15_ = row;
							_tmp16_ = index;
							plank_surface_exponential_blur_inner (&_tmp15_[_tmp16_ * 4], &zA, &zR, &zG, &zB, alpha);
						}
					}
				}
				{
					gint index = 0;
					index = endX - 2;
					{
						gboolean _tmp17_ = FALSE;
						_tmp17_ = TRUE;
						while (TRUE) {
							gint _tmp19_;
							guint8* _tmp20_;
							gint _tmp21_;
							if (!_tmp17_) {
								gint _tmp18_;
								_tmp18_ = index;
								index = _tmp18_ - 1;
							}
							_tmp17_ = FALSE;
							_tmp19_ = index;
							if (!(_tmp19_ >= startX)) {
								break;
							}
							_tmp20_ = row;
							_tmp21_ = index;
							plank_surface_exponential_blur_inner (&_tmp20_[_tmp21_ * 4], &zA, &zR, &zG, &zB, alpha);
						}
					}
				}
			}
		}
	}
}


static inline void
plank_surface_exponential_blur_inner (guint8* pixel,
                                      gint* zA,
                                      gint* zR,
                                      gint* zG,
                                      gint* zB,
                                      gint alpha)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	guint8 _tmp6_;
	guint8 _tmp7_;
	_tmp0_ = pixel[0];
	*zA = (*zA) + ((alpha * ((_tmp0_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION) - (*zA))) >> PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION);
	_tmp1_ = pixel[1];
	*zR = (*zR) + ((alpha * ((_tmp1_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION) - (*zR))) >> PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION);
	_tmp2_ = pixel[2];
	*zG = (*zG) + ((alpha * ((_tmp2_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION) - (*zG))) >> PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION);
	_tmp3_ = pixel[3];
	*zB = (*zB) + ((alpha * ((_tmp3_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION) - (*zB))) >> PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION);
	pixel[0] = (guint8) ((*zA) >> PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION);
	_tmp4_ = pixel[0];
	pixel[1] = (guint8) ((*zR) >> PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION);
	_tmp5_ = pixel[1];
	pixel[2] = (guint8) ((*zG) >> PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION);
	_tmp6_ = pixel[2];
	pixel[3] = (guint8) ((*zB) >> PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION);
	_tmp7_ = pixel[3];
}


/**
 * Performs a gaussian blur on the surface.
 * ''Note: This method is wickedly slow''
 *
 * @param radius the radius of the blur
 */
static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}


static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		PlankSurface* self;
		self = _data6_->self;
		_data6_->shiftar = (g_free (_data6_->shiftar), NULL);
		_data6_->bbuffer = (g_free (_data6_->bbuffer), NULL);
		_data6_->abuffer = (g_free (_data6_->abuffer), NULL);
		_data6_->kernel = (g_free (_data6_->kernel), NULL);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}


static void*
__lambda6_ (Block6Data* _data6_)
{
	PlankSurface* self;
	void* result = NULL;
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	self = _data6_->self;
	_tmp0_ = _data6_->abuffer;
	_tmp0__length1 = _data6_->abuffer_length1;
	_tmp1_ = _data6_->bbuffer;
	_tmp1__length1 = _data6_->bbuffer_length1;
	_tmp2_ = _data6_->kernel;
	_tmp2__length1 = _data6_->kernel_length1;
	_tmp3_ = _data6_->gaussWidth;
	_tmp4_ = _data6_->width;
	_tmp5_ = _data6_->height;
	_tmp6_ = _data6_->height;
	_tmp7_ = _data6_->shiftar;
	_tmp7__length1 = _data6_->shiftar_length1;
	_tmp7__length2 = _data6_->shiftar_length2;
	plank_surface_gaussian_blur_horizontal (_tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_, 0, _tmp6_ / 2, _tmp7_, _tmp7__length1, _tmp7__length2);
	result = NULL;
	return result;
}


static gpointer
___lambda6__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda6_ (self);
	block6_data_unref (self);
	return result;
}


static void*
__lambda7_ (Block6Data* _data6_)
{
	PlankSurface* self;
	void* result = NULL;
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	self = _data6_->self;
	_tmp0_ = _data6_->bbuffer;
	_tmp0__length1 = _data6_->bbuffer_length1;
	_tmp1_ = _data6_->abuffer;
	_tmp1__length1 = _data6_->abuffer_length1;
	_tmp2_ = _data6_->kernel;
	_tmp2__length1 = _data6_->kernel_length1;
	_tmp3_ = _data6_->gaussWidth;
	_tmp4_ = _data6_->width;
	_tmp5_ = _data6_->height;
	_tmp6_ = _data6_->width;
	_tmp7_ = _data6_->shiftar;
	_tmp7__length1 = _data6_->shiftar_length1;
	_tmp7__length2 = _data6_->shiftar_length2;
	plank_surface_gaussian_blur_vertical (_tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_, 0, _tmp6_ / 2, _tmp7_, _tmp7__length1, _tmp7__length2);
	result = NULL;
	return result;
}


static gpointer
___lambda7__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda7_ (self);
	block6_data_unref (self);
	return result;
}


void
plank_surface_gaussian_blur (PlankSurface* self,
                             gint radius)
{
	Block6Data* _data6_;
	gint _tmp0_;
	gint _tmp1_;
	gdouble* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	cairo_surface_t* original = NULL;
	gint _tmp5_;
	gint _tmp6_;
	cairo_surface_t* _tmp7_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp8_;
	cairo_t* _tmp9_;
	cairo_t* _tmp10_;
	cairo_t* _tmp11_;
	cairo_surface_t* _tmp12_;
	cairo_t* _tmp13_;
	guint8* src = NULL;
	cairo_surface_t* _tmp14_;
	guchar* _tmp15_;
	gint size = 0;
	gint _tmp16_;
	cairo_surface_t* _tmp17_;
	gint _tmp18_;
	gdouble* _tmp19_;
	gint _tmp20_;
	gdouble* _tmp21_;
	gint _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
	gint* _tmp35_;
	GThread* th = NULL;
	GThread* _tmp60_;
	gdouble* _tmp61_;
	gint _tmp61__length1;
	gdouble* _tmp62_;
	gint _tmp62__length1;
	gdouble* _tmp63_;
	gint _tmp63__length1;
	gint _tmp64_;
	gint _tmp65_;
	gint _tmp66_;
	gint _tmp67_;
	gint _tmp68_;
	gint* _tmp69_;
	gint _tmp69__length1;
	gint _tmp69__length2;
	GThread* _tmp70_;
	GThread* _tmp71_;
	gdouble* _tmp72_;
	gint _tmp72__length1;
	gint _tmp73_;
	gint _tmp74_;
	gint _tmp75_;
	gint _tmp76_;
	gint* _tmp77_;
	GThread* th2 = NULL;
	GThread* _tmp103_;
	gdouble* _tmp104_;
	gint _tmp104__length1;
	gdouble* _tmp105_;
	gint _tmp105__length1;
	gdouble* _tmp106_;
	gint _tmp106__length1;
	gint _tmp107_;
	gint _tmp108_;
	gint _tmp109_;
	gint _tmp110_;
	gint _tmp111_;
	gint* _tmp112_;
	gint _tmp112__length1;
	gint _tmp112__length2;
	GThread* _tmp113_;
	GThread* _tmp114_;
	cairo_surface_t* _tmp125_;
	cairo_t* target_cr = NULL;
	cairo_t* _tmp126_;
	cairo_t* _tmp127_;
	cairo_t* _tmp128_;
	cairo_t* _tmp129_;
	cairo_surface_t* _tmp130_;
	cairo_t* _tmp131_;
	cairo_t* _tmp132_;
	g_return_if_fail (self != NULL);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = g_object_ref (self);
	if (radius < 1) {
		block6_data_unref (_data6_);
		_data6_ = NULL;
		return;
	}
	_data6_->gaussWidth = (radius * 2) + 1;
	_tmp0_ = _data6_->gaussWidth;
	_tmp2_ = plank_surface_build_gaussian_kernel (_tmp0_, &_tmp1_);
	_data6_->kernel = _tmp2_;
	_data6_->kernel_length1 = _tmp1_;
	_data6_->_kernel_size_ = _data6_->kernel_length1;
	_tmp3_ = self->priv->_Width;
	_data6_->width = _tmp3_;
	_tmp4_ = self->priv->_Height;
	_data6_->height = _tmp4_;
	_tmp5_ = _data6_->width;
	_tmp6_ = _data6_->height;
	_tmp7_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp5_, _tmp6_);
	original = _tmp7_;
	_tmp8_ = original;
	_tmp9_ = cairo_create (_tmp8_);
	cr = _tmp9_;
	_tmp10_ = cr;
	cairo_set_operator (_tmp10_, CAIRO_OPERATOR_SOURCE);
	_tmp11_ = cr;
	_tmp12_ = self->priv->_Internal;
	cairo_set_source_surface (_tmp11_, _tmp12_, (gdouble) 0, (gdouble) 0);
	_tmp13_ = cr;
	cairo_paint (_tmp13_);
	_tmp14_ = original;
	_tmp15_ = cairo_image_surface_get_data (_tmp14_);
	src = _tmp15_;
	_tmp16_ = _data6_->height;
	_tmp17_ = original;
	size = _tmp16_ * cairo_image_surface_get_stride (_tmp17_);
	_tmp18_ = size;
	_tmp19_ = g_new0 (gdouble, _tmp18_);
	_data6_->abuffer = _tmp19_;
	_data6_->abuffer_length1 = _tmp18_;
	_data6_->_abuffer_size_ = _data6_->abuffer_length1;
	_tmp20_ = size;
	_tmp21_ = g_new0 (gdouble, _tmp20_);
	_data6_->bbuffer = _tmp21_;
	_data6_->bbuffer_length1 = _tmp20_;
	_data6_->_bbuffer_size_ = _data6_->bbuffer_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp22_ = FALSE;
			_tmp22_ = TRUE;
			while (TRUE) {
				gint _tmp24_;
				gint _tmp25_;
				gdouble* _tmp26_;
				gint _tmp26__length1;
				gint _tmp27_;
				guint8* _tmp28_;
				gint _tmp29_;
				guint8 _tmp30_;
				gdouble _tmp31_;
				if (!_tmp22_) {
					gint _tmp23_;
					_tmp23_ = i;
					i = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				_tmp24_ = i;
				_tmp25_ = size;
				if (!(_tmp24_ < _tmp25_)) {
					break;
				}
				_tmp26_ = _data6_->abuffer;
				_tmp26__length1 = _data6_->abuffer_length1;
				_tmp27_ = i;
				_tmp28_ = src;
				_tmp29_ = i;
				_tmp30_ = _tmp28_[_tmp29_];
				_tmp26_[_tmp27_] = (gdouble) _tmp30_;
				_tmp31_ = _tmp26_[_tmp27_];
			}
		}
	}
	_tmp32_ = _data6_->width;
	_tmp33_ = _data6_->height;
	_tmp34_ = _data6_->gaussWidth;
	_tmp35_ = g_new0 (gint, MAX (_tmp32_, _tmp33_) * _tmp34_);
	_data6_->shiftar = _tmp35_;
	_data6_->shiftar_length1 = MAX (_tmp32_, _tmp33_);
	_data6_->shiftar_length2 = _tmp34_;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp36_ = FALSE;
			_tmp36_ = TRUE;
			while (TRUE) {
				gint _tmp38_;
				gint _tmp39_;
				if (!_tmp36_) {
					gint _tmp37_;
					_tmp37_ = x;
					x = _tmp37_ + 1;
				}
				_tmp36_ = FALSE;
				_tmp38_ = x;
				_tmp39_ = _data6_->width;
				if (!(_tmp38_ < _tmp39_)) {
					break;
				}
				{
					gint k = 0;
					k = 0;
					{
						gboolean _tmp40_ = FALSE;
						_tmp40_ = TRUE;
						while (TRUE) {
							gint _tmp42_;
							gint _tmp43_;
							gint shift = 0;
							gint _tmp44_;
							gboolean _tmp45_ = FALSE;
							gint _tmp46_;
							gint _tmp47_;
							if (!_tmp40_) {
								gint _tmp41_;
								_tmp41_ = k;
								k = _tmp41_ + 1;
							}
							_tmp40_ = FALSE;
							_tmp42_ = k;
							_tmp43_ = _data6_->gaussWidth;
							if (!(_tmp42_ < _tmp43_)) {
								break;
							}
							_tmp44_ = k;
							shift = _tmp44_ - radius;
							_tmp46_ = x;
							_tmp47_ = shift;
							if ((_tmp46_ + _tmp47_) <= 0) {
								_tmp45_ = TRUE;
							} else {
								gint _tmp48_;
								gint _tmp49_;
								gint _tmp50_;
								_tmp48_ = x;
								_tmp49_ = shift;
								_tmp50_ = _data6_->width;
								_tmp45_ = (_tmp48_ + _tmp49_) >= _tmp50_;
							}
							if (_tmp45_) {
								gint* _tmp51_;
								gint _tmp51__length1;
								gint _tmp51__length2;
								gint _tmp52_;
								gint _tmp53_;
								gint _tmp54_;
								_tmp51_ = _data6_->shiftar;
								_tmp51__length1 = _data6_->shiftar_length1;
								_tmp51__length2 = _data6_->shiftar_length2;
								_tmp52_ = x;
								_tmp53_ = k;
								_tmp51_[(_tmp52_ * _tmp51__length2) + _tmp53_] = 0;
								_tmp54_ = _tmp51_[(_tmp52_ * _tmp51__length2) + _tmp53_];
							} else {
								gint* _tmp55_;
								gint _tmp55__length1;
								gint _tmp55__length2;
								gint _tmp56_;
								gint _tmp57_;
								gint _tmp58_;
								gint _tmp59_;
								_tmp55_ = _data6_->shiftar;
								_tmp55__length1 = _data6_->shiftar_length1;
								_tmp55__length2 = _data6_->shiftar_length2;
								_tmp56_ = x;
								_tmp57_ = k;
								_tmp58_ = shift;
								_tmp55_[(_tmp56_ * _tmp55__length2) + _tmp57_] = _tmp58_ * 4;
								_tmp59_ = _tmp55_[(_tmp56_ * _tmp55__length2) + _tmp57_];
							}
						}
					}
				}
			}
		}
	}
	_tmp60_ = g_thread_new (NULL, ___lambda6__gthread_func, block6_data_ref (_data6_));
	th = _tmp60_;
	_tmp61_ = _data6_->abuffer;
	_tmp61__length1 = _data6_->abuffer_length1;
	_tmp62_ = _data6_->bbuffer;
	_tmp62__length1 = _data6_->bbuffer_length1;
	_tmp63_ = _data6_->kernel;
	_tmp63__length1 = _data6_->kernel_length1;
	_tmp64_ = _data6_->gaussWidth;
	_tmp65_ = _data6_->width;
	_tmp66_ = _data6_->height;
	_tmp67_ = _data6_->height;
	_tmp68_ = _data6_->height;
	_tmp69_ = _data6_->shiftar;
	_tmp69__length1 = _data6_->shiftar_length1;
	_tmp69__length2 = _data6_->shiftar_length2;
	plank_surface_gaussian_blur_horizontal (_tmp61_, _tmp62_, _tmp63_, _tmp64_, _tmp65_, _tmp66_, _tmp67_ / 2, _tmp68_, _tmp69_, _tmp69__length1, _tmp69__length2);
	_tmp70_ = th;
	_tmp71_ = _g_thread_ref0 (_tmp70_);
	g_thread_join (_tmp71_);
	_tmp72_ = _data6_->abuffer;
	_tmp72__length1 = _data6_->abuffer_length1;
	_tmp73_ = size;
	memset (_tmp72_, 0, (gsize) (sizeof (gdouble) * _tmp73_));
	_tmp74_ = _data6_->width;
	_tmp75_ = _data6_->height;
	_tmp76_ = _data6_->gaussWidth;
	_tmp77_ = g_new0 (gint, MAX (_tmp74_, _tmp75_) * _tmp76_);
	_data6_->shiftar = (g_free (_data6_->shiftar), NULL);
	_data6_->shiftar = _tmp77_;
	_data6_->shiftar_length1 = MAX (_tmp74_, _tmp75_);
	_data6_->shiftar_length2 = _tmp76_;
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp78_ = FALSE;
			_tmp78_ = TRUE;
			while (TRUE) {
				gint _tmp80_;
				gint _tmp81_;
				if (!_tmp78_) {
					gint _tmp79_;
					_tmp79_ = y;
					y = _tmp79_ + 1;
				}
				_tmp78_ = FALSE;
				_tmp80_ = y;
				_tmp81_ = _data6_->height;
				if (!(_tmp80_ < _tmp81_)) {
					break;
				}
				{
					gint k = 0;
					k = 0;
					{
						gboolean _tmp82_ = FALSE;
						_tmp82_ = TRUE;
						while (TRUE) {
							gint _tmp84_;
							gint _tmp85_;
							gint shift = 0;
							gint _tmp86_;
							gboolean _tmp87_ = FALSE;
							gint _tmp88_;
							gint _tmp89_;
							if (!_tmp82_) {
								gint _tmp83_;
								_tmp83_ = k;
								k = _tmp83_ + 1;
							}
							_tmp82_ = FALSE;
							_tmp84_ = k;
							_tmp85_ = _data6_->gaussWidth;
							if (!(_tmp84_ < _tmp85_)) {
								break;
							}
							_tmp86_ = k;
							shift = _tmp86_ - radius;
							_tmp88_ = y;
							_tmp89_ = shift;
							if ((_tmp88_ + _tmp89_) <= 0) {
								_tmp87_ = TRUE;
							} else {
								gint _tmp90_;
								gint _tmp91_;
								gint _tmp92_;
								_tmp90_ = y;
								_tmp91_ = shift;
								_tmp92_ = _data6_->height;
								_tmp87_ = (_tmp90_ + _tmp91_) >= _tmp92_;
							}
							if (_tmp87_) {
								gint* _tmp93_;
								gint _tmp93__length1;
								gint _tmp93__length2;
								gint _tmp94_;
								gint _tmp95_;
								gint _tmp96_;
								_tmp93_ = _data6_->shiftar;
								_tmp93__length1 = _data6_->shiftar_length1;
								_tmp93__length2 = _data6_->shiftar_length2;
								_tmp94_ = y;
								_tmp95_ = k;
								_tmp93_[(_tmp94_ * _tmp93__length2) + _tmp95_] = 0;
								_tmp96_ = _tmp93_[(_tmp94_ * _tmp93__length2) + _tmp95_];
							} else {
								gint* _tmp97_;
								gint _tmp97__length1;
								gint _tmp97__length2;
								gint _tmp98_;
								gint _tmp99_;
								gint _tmp100_;
								gint _tmp101_;
								gint _tmp102_;
								_tmp97_ = _data6_->shiftar;
								_tmp97__length1 = _data6_->shiftar_length1;
								_tmp97__length2 = _data6_->shiftar_length2;
								_tmp98_ = y;
								_tmp99_ = k;
								_tmp100_ = shift;
								_tmp101_ = _data6_->width;
								_tmp97_[(_tmp98_ * _tmp97__length2) + _tmp99_] = (_tmp100_ * _tmp101_) * 4;
								_tmp102_ = _tmp97_[(_tmp98_ * _tmp97__length2) + _tmp99_];
							}
						}
					}
				}
			}
		}
	}
	_tmp103_ = g_thread_new (NULL, ___lambda7__gthread_func, block6_data_ref (_data6_));
	th2 = _tmp103_;
	_tmp104_ = _data6_->bbuffer;
	_tmp104__length1 = _data6_->bbuffer_length1;
	_tmp105_ = _data6_->abuffer;
	_tmp105__length1 = _data6_->abuffer_length1;
	_tmp106_ = _data6_->kernel;
	_tmp106__length1 = _data6_->kernel_length1;
	_tmp107_ = _data6_->gaussWidth;
	_tmp108_ = _data6_->width;
	_tmp109_ = _data6_->height;
	_tmp110_ = _data6_->width;
	_tmp111_ = _data6_->width;
	_tmp112_ = _data6_->shiftar;
	_tmp112__length1 = _data6_->shiftar_length1;
	_tmp112__length2 = _data6_->shiftar_length2;
	plank_surface_gaussian_blur_vertical (_tmp104_, _tmp105_, _tmp106_, _tmp107_, _tmp108_, _tmp109_, _tmp110_ / 2, _tmp111_, _tmp112_, _tmp112__length1, _tmp112__length2);
	_tmp113_ = th2;
	_tmp114_ = _g_thread_ref0 (_tmp113_);
	g_thread_join (_tmp114_);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp115_ = FALSE;
			_tmp115_ = TRUE;
			while (TRUE) {
				gint _tmp117_;
				gint _tmp118_;
				guint8* _tmp119_;
				gint _tmp120_;
				gdouble* _tmp121_;
				gint _tmp121__length1;
				gint _tmp122_;
				gdouble _tmp123_;
				guint8 _tmp124_;
				if (!_tmp115_) {
					gint _tmp116_;
					_tmp116_ = i;
					i = _tmp116_ + 1;
				}
				_tmp115_ = FALSE;
				_tmp117_ = i;
				_tmp118_ = size;
				if (!(_tmp117_ < _tmp118_)) {
					break;
				}
				_tmp119_ = src;
				_tmp120_ = i;
				_tmp121_ = _data6_->abuffer;
				_tmp121__length1 = _data6_->abuffer_length1;
				_tmp122_ = i;
				_tmp123_ = _tmp121_[_tmp122_];
				_tmp119_[_tmp120_] = (guint8) _tmp123_;
				_tmp124_ = _tmp119_[_tmp120_];
			}
		}
	}
	_tmp125_ = original;
	cairo_surface_mark_dirty (_tmp125_);
	_tmp126_ = self->priv->_Context;
	target_cr = _tmp126_;
	_tmp127_ = target_cr;
	cairo_save (_tmp127_);
	_tmp128_ = target_cr;
	cairo_set_operator (_tmp128_, CAIRO_OPERATOR_SOURCE);
	_tmp129_ = target_cr;
	_tmp130_ = original;
	cairo_set_source_surface (_tmp129_, _tmp130_, (gdouble) 0, (gdouble) 0);
	_tmp131_ = target_cr;
	cairo_paint (_tmp131_);
	_tmp132_ = target_cr;
	cairo_restore (_tmp132_);
	_g_thread_unref0 (th2);
	_g_thread_unref0 (th);
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (original);
	block6_data_unref (_data6_);
	_data6_ = NULL;
}


static void
plank_surface_gaussian_blur_horizontal (gdouble* src,
                                        gdouble* dest,
                                        gdouble* kernel,
                                        gint gaussWidth,
                                        gint width,
                                        gint height,
                                        gint startRow,
                                        gint endRow,
                                        gint* shift,
                                        int shift_length1,
                                        int shift_length2)
{
	guint32 cur_pixel = 0U;
	cur_pixel = (guint32) ((startRow * width) * 4);
	{
		gint y = 0;
		y = startRow;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = y;
					y = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = y;
				if (!(_tmp2_ < endRow)) {
					break;
				}
				{
					gint x = 0;
					x = 0;
					{
						gboolean _tmp3_ = FALSE;
						_tmp3_ = TRUE;
						while (TRUE) {
							gint _tmp5_;
							guint32 _tmp35_;
							if (!_tmp3_) {
								gint _tmp4_;
								_tmp4_ = x;
								x = _tmp4_ + 1;
							}
							_tmp3_ = FALSE;
							_tmp5_ = x;
							if (!(_tmp5_ < width)) {
								break;
							}
							{
								gint k = 0;
								k = 0;
								{
									gboolean _tmp6_ = FALSE;
									_tmp6_ = TRUE;
									while (TRUE) {
										gint _tmp8_;
										guint32 source = 0U;
										guint32 _tmp9_;
										gint _tmp10_;
										gint _tmp11_;
										gint _tmp12_;
										gdouble kernel_k = 0.0;
										gint _tmp13_;
										gdouble _tmp14_;
										guint32 _tmp15_;
										guint32 _tmp16_;
										gdouble _tmp17_;
										gdouble _tmp18_;
										gdouble _tmp19_;
										guint32 _tmp20_;
										guint32 _tmp21_;
										gdouble _tmp22_;
										gdouble _tmp23_;
										gdouble _tmp24_;
										guint32 _tmp25_;
										guint32 _tmp26_;
										gdouble _tmp27_;
										gdouble _tmp28_;
										gdouble _tmp29_;
										guint32 _tmp30_;
										guint32 _tmp31_;
										gdouble _tmp32_;
										gdouble _tmp33_;
										gdouble _tmp34_;
										if (!_tmp6_) {
											gint _tmp7_;
											_tmp7_ = k;
											k = _tmp7_ + 1;
										}
										_tmp6_ = FALSE;
										_tmp8_ = k;
										if (!(_tmp8_ < gaussWidth)) {
											break;
										}
										_tmp9_ = cur_pixel;
										_tmp10_ = x;
										_tmp11_ = k;
										_tmp12_ = shift[(_tmp10_ * shift_length2) + _tmp11_];
										source = _tmp9_ + _tmp12_;
										_tmp13_ = k;
										_tmp14_ = kernel[_tmp13_];
										kernel_k = _tmp14_;
										_tmp15_ = cur_pixel;
										_tmp16_ = source;
										_tmp17_ = src[_tmp16_ + 0];
										_tmp18_ = kernel_k;
										dest[_tmp15_ + 0] += _tmp17_ * _tmp18_;
										_tmp19_ = dest[_tmp15_ + 0];
										_tmp20_ = cur_pixel;
										_tmp21_ = source;
										_tmp22_ = src[_tmp21_ + 1];
										_tmp23_ = kernel_k;
										dest[_tmp20_ + 1] += _tmp22_ * _tmp23_;
										_tmp24_ = dest[_tmp20_ + 1];
										_tmp25_ = cur_pixel;
										_tmp26_ = source;
										_tmp27_ = src[_tmp26_ + 2];
										_tmp28_ = kernel_k;
										dest[_tmp25_ + 2] += _tmp27_ * _tmp28_;
										_tmp29_ = dest[_tmp25_ + 2];
										_tmp30_ = cur_pixel;
										_tmp31_ = source;
										_tmp32_ = src[_tmp31_ + 3];
										_tmp33_ = kernel_k;
										dest[_tmp30_ + 3] += _tmp32_ * _tmp33_;
										_tmp34_ = dest[_tmp30_ + 3];
									}
								}
							}
							_tmp35_ = cur_pixel;
							cur_pixel = _tmp35_ + 4;
						}
					}
				}
			}
		}
	}
}


static void
plank_surface_gaussian_blur_vertical (gdouble* src,
                                      gdouble* dest,
                                      gdouble* kernel,
                                      gint gaussWidth,
                                      gint width,
                                      gint height,
                                      gint startCol,
                                      gint endCol,
                                      gint* shift,
                                      int shift_length1,
                                      int shift_length2)
{
	guint32 cur_pixel = 0U;
	cur_pixel = (guint32) (startCol * 4);
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				guint32 _tmp36_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = y;
					y = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = y;
				if (!(_tmp2_ < height)) {
					break;
				}
				{
					gint x = 0;
					x = startCol;
					{
						gboolean _tmp3_ = FALSE;
						_tmp3_ = TRUE;
						while (TRUE) {
							gint _tmp5_;
							guint32 _tmp35_;
							if (!_tmp3_) {
								gint _tmp4_;
								_tmp4_ = x;
								x = _tmp4_ + 1;
							}
							_tmp3_ = FALSE;
							_tmp5_ = x;
							if (!(_tmp5_ < endCol)) {
								break;
							}
							{
								gint k = 0;
								k = 0;
								{
									gboolean _tmp6_ = FALSE;
									_tmp6_ = TRUE;
									while (TRUE) {
										gint _tmp8_;
										guint32 source = 0U;
										guint32 _tmp9_;
										gint _tmp10_;
										gint _tmp11_;
										gint _tmp12_;
										gdouble kernel_k = 0.0;
										gint _tmp13_;
										gdouble _tmp14_;
										guint32 _tmp15_;
										guint32 _tmp16_;
										gdouble _tmp17_;
										gdouble _tmp18_;
										gdouble _tmp19_;
										guint32 _tmp20_;
										guint32 _tmp21_;
										gdouble _tmp22_;
										gdouble _tmp23_;
										gdouble _tmp24_;
										guint32 _tmp25_;
										guint32 _tmp26_;
										gdouble _tmp27_;
										gdouble _tmp28_;
										gdouble _tmp29_;
										guint32 _tmp30_;
										guint32 _tmp31_;
										gdouble _tmp32_;
										gdouble _tmp33_;
										gdouble _tmp34_;
										if (!_tmp6_) {
											gint _tmp7_;
											_tmp7_ = k;
											k = _tmp7_ + 1;
										}
										_tmp6_ = FALSE;
										_tmp8_ = k;
										if (!(_tmp8_ < gaussWidth)) {
											break;
										}
										_tmp9_ = cur_pixel;
										_tmp10_ = y;
										_tmp11_ = k;
										_tmp12_ = shift[(_tmp10_ * shift_length2) + _tmp11_];
										source = _tmp9_ + _tmp12_;
										_tmp13_ = k;
										_tmp14_ = kernel[_tmp13_];
										kernel_k = _tmp14_;
										_tmp15_ = cur_pixel;
										_tmp16_ = source;
										_tmp17_ = src[_tmp16_ + 0];
										_tmp18_ = kernel_k;
										dest[_tmp15_ + 0] += _tmp17_ * _tmp18_;
										_tmp19_ = dest[_tmp15_ + 0];
										_tmp20_ = cur_pixel;
										_tmp21_ = source;
										_tmp22_ = src[_tmp21_ + 1];
										_tmp23_ = kernel_k;
										dest[_tmp20_ + 1] += _tmp22_ * _tmp23_;
										_tmp24_ = dest[_tmp20_ + 1];
										_tmp25_ = cur_pixel;
										_tmp26_ = source;
										_tmp27_ = src[_tmp26_ + 2];
										_tmp28_ = kernel_k;
										dest[_tmp25_ + 2] += _tmp27_ * _tmp28_;
										_tmp29_ = dest[_tmp25_ + 2];
										_tmp30_ = cur_pixel;
										_tmp31_ = source;
										_tmp32_ = src[_tmp31_ + 3];
										_tmp33_ = kernel_k;
										dest[_tmp30_ + 3] += _tmp32_ * _tmp33_;
										_tmp34_ = dest[_tmp30_ + 3];
									}
								}
							}
							_tmp35_ = cur_pixel;
							cur_pixel = _tmp35_ + 4;
						}
					}
				}
				_tmp36_ = cur_pixel;
				cur_pixel = _tmp36_ + (((width - endCol) + startCol) * 4);
			}
		}
	}
}


static gdouble*
plank_surface_build_gaussian_kernel (gint gaussWidth,
                                     int* result_length1)
{
	gdouble* result = NULL;
	gdouble* kernel = NULL;
	gdouble* _tmp0_;
	gint kernel_length1;
	gint _kernel_size_;
	gdouble sd = 0.0;
	gint range = 0;
	gdouble mean = 0.0;
	gint _tmp1_;
	gdouble _tmp2_;
	gdouble gaussSum = 0.0;
	gdouble* _tmp16_;
	gint _tmp16__length1;
	gdouble* _tmp30_;
	gint _tmp30__length1;
	_vala_return_val_if_fail ((gaussWidth % 2) == 1, "gaussWidth % 2 == 1", NULL);
	_tmp0_ = g_new0 (gdouble, gaussWidth);
	kernel = _tmp0_;
	kernel_length1 = gaussWidth;
	_kernel_size_ = kernel_length1;
	sd = 255.0;
	range = gaussWidth;
	_tmp1_ = range;
	_tmp2_ = sd;
	mean = _tmp1_ / _tmp2_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_;
				gdouble* _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				gdouble* _tmp8_;
				gint _tmp8__length1;
				gint _tmp9_;
				gint _tmp10_;
				gdouble _tmp11_;
				gint _tmp12_;
				gdouble _tmp13_;
				gdouble _tmp14_;
				gdouble _tmp15_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = i;
				if (!(_tmp5_ < ((gaussWidth / 2) + 1))) {
					break;
				}
				_tmp6_ = kernel;
				_tmp6__length1 = kernel_length1;
				_tmp7_ = i;
				_tmp8_ = kernel;
				_tmp8__length1 = kernel_length1;
				_tmp9_ = i;
				_tmp10_ = i;
				_tmp11_ = mean;
				_tmp12_ = range;
				_tmp13_ = sd;
				_tmp8_[_tmp9_] = pow (sin ((((_tmp10_ + 1) * G_PI_2) - _tmp11_) / _tmp12_), (gdouble) 2) * _tmp13_;
				_tmp14_ = _tmp8_[_tmp9_];
				_tmp6_[(gaussWidth - _tmp7_) - 1] = _tmp14_;
				_tmp15_ = _tmp6_[(gaussWidth - _tmp7_) - 1];
			}
		}
	}
	gaussSum = 0.0;
	_tmp16_ = kernel;
	_tmp16__length1 = kernel_length1;
	{
		gdouble* d_collection = NULL;
		gint d_collection_length1 = 0;
		gint _d_collection_size_ = 0;
		gint d_it = 0;
		d_collection = _tmp16_;
		d_collection_length1 = _tmp16__length1;
		for (d_it = 0; d_it < _tmp16__length1; d_it = d_it + 1) {
			gdouble d = 0.0;
			d = d_collection[d_it];
			{
				gdouble _tmp17_;
				gdouble _tmp18_;
				_tmp17_ = gaussSum;
				_tmp18_ = d;
				gaussSum = _tmp17_ + _tmp18_;
			}
		}
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp19_ = FALSE;
			_tmp19_ = TRUE;
			while (TRUE) {
				gint _tmp21_;
				gdouble* _tmp22_;
				gint _tmp22__length1;
				gdouble* _tmp23_;
				gint _tmp23__length1;
				gint _tmp24_;
				gdouble* _tmp25_;
				gint _tmp25__length1;
				gint _tmp26_;
				gdouble _tmp27_;
				gdouble _tmp28_;
				gdouble _tmp29_;
				if (!_tmp19_) {
					gint _tmp20_;
					_tmp20_ = i;
					i = _tmp20_ + 1;
				}
				_tmp19_ = FALSE;
				_tmp21_ = i;
				_tmp22_ = kernel;
				_tmp22__length1 = kernel_length1;
				if (!(_tmp21_ < _tmp22__length1)) {
					break;
				}
				_tmp23_ = kernel;
				_tmp23__length1 = kernel_length1;
				_tmp24_ = i;
				_tmp25_ = kernel;
				_tmp25__length1 = kernel_length1;
				_tmp26_ = i;
				_tmp27_ = _tmp25_[_tmp26_];
				_tmp28_ = gaussSum;
				_tmp23_[_tmp24_] = _tmp27_ / _tmp28_;
				_tmp29_ = _tmp23_[_tmp24_];
			}
		}
	}
	_tmp30_ = kernel;
	_tmp30__length1 = kernel_length1;
	if (result_length1) {
		*result_length1 = _tmp30__length1;
	}
	result = _tmp30_;
	return result;
}


cairo_surface_t*
plank_surface_get_Internal (PlankSurface* self)
{
	cairo_surface_t* result;
	cairo_surface_t* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Internal;
	result = _tmp0_;
	return result;
}


static gpointer
_cairo_surface_reference0 (gpointer self)
{
	return self ? cairo_surface_reference (self) : NULL;
}


static void
plank_surface_set_Internal (PlankSurface* self,
                            cairo_surface_t* value)
{
	g_return_if_fail (self != NULL);
	if (plank_surface_get_Internal (self) != value) {
		cairo_surface_t* _tmp0_;
		_tmp0_ = _cairo_surface_reference0 (value);
		_cairo_surface_destroy0 (self->priv->_Internal);
		self->priv->_Internal = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, plank_surface_properties[PLANK_SURFACE_INTERNAL_PROPERTY]);
	}
}


gint
plank_surface_get_Width (PlankSurface* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_Width;
	result = _tmp0_;
	return result;
}


static void
plank_surface_set_Width (PlankSurface* self,
                         gint value)
{
	g_return_if_fail (self != NULL);
	if (plank_surface_get_Width (self) != value) {
		self->priv->_Width = value;
		g_object_notify_by_pspec ((GObject *) self, plank_surface_properties[PLANK_SURFACE_WIDTH_PROPERTY]);
	}
}


gint
plank_surface_get_Height (PlankSurface* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_Height;
	result = _tmp0_;
	return result;
}


static void
plank_surface_set_Height (PlankSurface* self,
                          gint value)
{
	g_return_if_fail (self != NULL);
	if (plank_surface_get_Height (self) != value) {
		self->priv->_Height = value;
		g_object_notify_by_pspec ((GObject *) self, plank_surface_properties[PLANK_SURFACE_HEIGHT_PROPERTY]);
	}
}


cairo_t*
plank_surface_get_Context (PlankSurface* self)
{
	cairo_t* result;
	cairo_t* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Context;
	result = _tmp0_;
	return result;
}


static gpointer
_cairo_reference0 (gpointer self)
{
	return self ? cairo_reference (self) : NULL;
}


static void
plank_surface_set_Context (PlankSurface* self,
                           cairo_t* value)
{
	g_return_if_fail (self != NULL);
	if (plank_surface_get_Context (self) != value) {
		cairo_t* _tmp0_;
		_tmp0_ = _cairo_reference0 (value);
		_cairo_destroy0 (self->priv->_Context);
		self->priv->_Context = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, plank_surface_properties[PLANK_SURFACE_CONTEXT_PROPERTY]);
	}
}


static GObject *
plank_surface_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankSurface * self;
	cairo_surface_t* _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	parent_class = G_OBJECT_CLASS (plank_surface_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_SURFACE, PlankSurface);
	_tmp0_ = self->priv->_Internal;
	_tmp1_ = cairo_create (_tmp0_);
	_tmp2_ = _tmp1_;
	plank_surface_set_Context (self, _tmp2_);
	_cairo_destroy0 (_tmp2_);
	return obj;
}


static void
plank_surface_class_init (PlankSurfaceClass * klass)
{
	plank_surface_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PlankSurfacePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_surface_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_surface_set_property;
	G_OBJECT_CLASS (klass)->constructor = plank_surface_constructor;
	G_OBJECT_CLASS (klass)->finalize = plank_surface_finalize;
	/**
	 * The internal {@link Cairo.Surface} backing the surface.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_SURFACE_INTERNAL_PROPERTY, plank_surface_properties[PLANK_SURFACE_INTERNAL_PROPERTY] = g_param_spec_pointer ("Internal", "Internal", "Internal", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	 * The width of the surface.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_SURFACE_WIDTH_PROPERTY, plank_surface_properties[PLANK_SURFACE_WIDTH_PROPERTY] = g_param_spec_int ("Width", "Width", "Width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	 * The height of the surface.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_SURFACE_HEIGHT_PROPERTY, plank_surface_properties[PLANK_SURFACE_HEIGHT_PROPERTY] = g_param_spec_int ("Height", "Height", "Height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	 * A {@link Cairo.Context} for the surface.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_SURFACE_CONTEXT_PROPERTY, plank_surface_properties[PLANK_SURFACE_CONTEXT_PROPERTY] = g_param_spec_pointer ("Context", "Context", "Context", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void
plank_surface_instance_init (PlankSurface * self)
{
	self->priv = PLANK_SURFACE_GET_PRIVATE (self);
}


static void
plank_surface_finalize (GObject * obj)
{
	PlankSurface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_SURFACE, PlankSurface);
	_cairo_surface_destroy0 (self->priv->_Internal);
	_cairo_destroy0 (self->priv->_Context);
	G_OBJECT_CLASS (plank_surface_parent_class)->finalize (obj);
}


/**
 * A surface is a wrapper class for a {@link Cairo.Surface}.
 * It encapsulates a surface/context and provides utility methods.
 */
GType
plank_surface_get_type (void)
{
	static volatile gsize plank_surface_type_id__volatile = 0;
	if (g_once_init_enter (&plank_surface_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankSurfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_surface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankSurface), 0, (GInstanceInitFunc) plank_surface_instance_init, NULL };
		GType plank_surface_type_id;
		plank_surface_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankSurface", &g_define_type_info, 0);
		g_once_init_leave (&plank_surface_type_id__volatile, plank_surface_type_id);
	}
	return plank_surface_type_id__volatile;
}


static void
_vala_plank_surface_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	PlankSurface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_SURFACE, PlankSurface);
	switch (property_id) {
		case PLANK_SURFACE_INTERNAL_PROPERTY:
		g_value_set_pointer (value, plank_surface_get_Internal (self));
		break;
		case PLANK_SURFACE_WIDTH_PROPERTY:
		g_value_set_int (value, plank_surface_get_Width (self));
		break;
		case PLANK_SURFACE_HEIGHT_PROPERTY:
		g_value_set_int (value, plank_surface_get_Height (self));
		break;
		case PLANK_SURFACE_CONTEXT_PROPERTY:
		g_value_set_pointer (value, plank_surface_get_Context (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_plank_surface_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	PlankSurface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_SURFACE, PlankSurface);
	switch (property_id) {
		case PLANK_SURFACE_INTERNAL_PROPERTY:
		plank_surface_set_Internal (self, g_value_get_pointer (value));
		break;
		case PLANK_SURFACE_WIDTH_PROPERTY:
		plank_surface_set_Width (self, g_value_get_int (value));
		break;
		case PLANK_SURFACE_HEIGHT_PROPERTY:
		plank_surface_set_Height (self, g_value_get_int (value));
		break;
		case PLANK_SURFACE_CONTEXT_PROPERTY:
		plank_surface_set_Context (self, g_value_get_pointer (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



